'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _colorManipulator = require('../../utils/colorManipulator');

var _IsMobile = require('../../utils/IsMobile');

var _IsMobile2 = _interopRequireDefault(_IsMobile);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var isMobile = _IsMobile2.default.Any();

function getStyles(props) {
	var padding = props.padding,
	    fullWidth = props.fullWidth;

	return {
		root: {
			display: fullWidth ? 'block' : 'inline-block',
			textAlign: 'center',
			padding: padding
		}
	};
}

var IconButton = function (_Component) {
	_inherits(IconButton, _Component);

	function IconButton(props) {
		_classCallCheck(this, IconButton);

		var _this = _possibleConstructorReturn(this, (IconButton.__proto__ || Object.getPrototypeOf(IconButton)).call(this, props));

		_this.state = {
			hovered: false,
			toggled: props.toggled
		};
		return _this;
	}

	_createClass(IconButton, [{
		key: 'handleMouseEnter',
		value: function handleMouseEnter(e) {
			if (!isMobile) {
				this.setState({ hovered: true });
				if (this.props.onMouseEnter) {
					this.props.onMouseEnter(e);
				}
			}
		}
	}, {
		key: 'handleMouseLeave',
		value: function handleMouseLeave(e) {
			if (!isMobile) {
				this.setState({ hovered: false });
				if (this.props.onMouseLeave) {
					this.props.onMouseLeave(e);
				}
			}
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(newProps) {
			if (newProps.toggled !== undefined) {
				this.setState({
					toggled: newProps.toggled
				});
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    icon = _props.icon,
			    style = _props.style,
			    color = _props.color,
			    hoverColor = _props.hoverColor,
			    toggle = _props.toggle,
			    toggledColor = _props.toggledColor,
			    isLimitClickUp = _props.isLimitClickUp,
			    _onClick = _props.onClick;


			var styles = getStyles(this.props);

			var iconColor = toggle && this.state.toggled ? toggledColor ? toggledColor : (0, _colorManipulator.lighten)(color, 0.2) : color;
			iconColor = this.state.hovered ? hoverColor ? hoverColor : (0, _colorManipulator.lighten)(color, 0.5) : iconColor;
			// console.log(this.state.toggled);
			var iconElement = _react2.default.cloneElement(icon, {
				color: iconColor
			});

			return _react2.default.createElement(
				'div',
				{
					style: Object.assign({}, styles.root, style),
					onMouseEnter: this.handleMouseEnter.bind(this),
					onMouseLeave: this.handleMouseLeave.bind(this),
					onClick: function onClick(e) {
						// console.log(this.state.toggled);
						if (toggle) {
							if (!isLimitClickUp || !_this2.state.toggled) {
								_this2.setState({ toggled: !_this2.state.toggled });
							}
						}
						if (_onClick) {
							_onClick(e);
						}
					} },
				iconElement
			);
		}
	}]);

	return IconButton;
}(_react.Component);

IconButton.propTypes = {
	icon: _react.PropTypes.node.isRequired,
	padding: _react.PropTypes.number,
	style: _react.PropTypes.object,
	color: _react.PropTypes.string,
	hoverColor: _react.PropTypes.string,
	toggle: _react.PropTypes.bool,
	toggled: _react.PropTypes.bool,
	toggledColor: _react.PropTypes.string,
	isLimitClickUp: _react.PropTypes.bool,
	onMouseEnter: _react.PropTypes.func,
	onMouseLeave: _react.PropTypes.func,
	onClick: _react.PropTypes.func,
	fullWidth: _react.PropTypes.bool
};
IconButton.defaultProps = {
	padding: 5,
	style: {},
	toggle: false,
	toggled: false,
	fullWidth: false,
	isLimitClickUp: false
};
exports.default = IconButton;