'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _colorManipulator = require('../../utils/colorManipulator');

var _colors = require('../../styles/colors');

var _constants = require('../../styles/constants');

var _Paper = require('../Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _Overlay = require('../Overlay');

var _Overlay2 = _interopRequireDefault(_Overlay);

var _IsMobile = require('../../utils/IsMobile');

var _IsMobile2 = _interopRequireDefault(_IsMobile);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var isMobile = _IsMobile2.default.Any();

function getStyles(props, state) {
	var fontSize = props.fontSize,
	    size = props.size,
	    labelColor = props.labelColor;

	if (props.type === 'default') {
		labelColor = _colors.GREY900;
	} else {
		labelColor = _colors.GREY100;
	}
	var padding = 8;
	switch (size) {
		case 'large':
			fontSize = Math.round(fontSize * (1 + 0.1));
			padding = Math.round(padding * (1 + 0.1));
			break;
		case 'small':
			fontSize = Math.round(fontSize * (1 - 0.1));
			padding = Math.round(padding * (1 - 0.1));
			break;
		case 'mini':
			fontSize = Math.round(fontSize * (1 - 0.3));
			padding = Math.round(padding * (1 - 0.3));
			break;
	}
	return {
		root: {
			display: props.fullWidth ? 'block' : 'inline-block',
			position: 'relative'
		},
		button: {
			padding: '0px 10px',
			textAlign: 'center'
		},
		item: {
			display: 'inline-block'
		},
		label: {
			color: labelColor,
			display: 'inline-block',
			padding: padding + 'px 0px',
			fontFamily: props.fontFamily,
			fontSize: fontSize
		},
		icon: {
			display: 'inline-block',
			verticalAlign: 'middle'
		},

		loadingParent: {
			position: 'absolute',
			top: 0,
			left: 0,
			width: '100%',
			height: '100%',
			backgroundColor: 'rgba(0, 0, 0, 0.5)'
		},

		loading: {
			boxSizing: 'border',
			border: '3px solid #f3f3f3',
			borderTop: '3px solid #3498db',
			borderRadius: '50%',
			width: 14,
			height: 14,
			position: 'absolute',
			top: 0,
			bottom: 0,
			left: 0,
			right: 0,
			margin: 'auto',
			animation: 'animation_' + state.random + ' 2s linear infinite'
		}
	};
}

var RaisedButton = function (_Component) {
	_inherits(RaisedButton, _Component);

	function RaisedButton(props) {
		_classCallCheck(this, RaisedButton);

		var _this = _possibleConstructorReturn(this, (RaisedButton.__proto__ || Object.getPrototypeOf(RaisedButton)).call(this, props));

		_this.state = {
			hovered: false,
			toggled: props.toggled,
			random: null,
			isDown: false
		};

		_this.type = 'RaisedButton';
		return _this;
	}

	_createClass(RaisedButton, [{
		key: 'generateLoadingAnimation',
		value: function generateLoadingAnimation() {
			var random = Math.round(Math.random() * 10000000);

			var style = document.createElement("style");
			var css = '@keyframes animation_' + random + ' {\n\t\t\t0% { transform: rotate(0deg); }\n\t\t\t100% { transform: rotate(360deg); }\n\t\t}';

			style.type = "text/css";
			style.appendChild(document.createTextNode(css));

			document.getElementsByTagName("head")[0].appendChild(style);

			return random;
		}
	}, {
		key: 'handleMouseEnter',
		value: function handleMouseEnter(e) {
			if (!isMobile) {
				this.setState({ hovered: true });
				if (this.props.onMouseEnter) {
					this.props.onMouseEnter(e);
				}
			}
		}
	}, {
		key: 'handleMouseLeave',
		value: function handleMouseLeave(e) {
			if (!isMobile) {
				this.setState({ hovered: false });
				if (this.props.onMouseLeave) {
					this.props.onMouseLeave(e);
				}
			}
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(newProps) {
			if (newProps.toggled !== undefined) {
				this.setState({
					toggled: newProps.toggled
				});
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    type = _props.type,
			    label = _props.label,
			    hoverColor = _props.hoverColor,
			    leftIcon = _props.leftIcon,
			    rightIcon = _props.rightIcon,
			    style = _props.style,
			    styleButton = _props.styleButton,
			    toggle = _props.toggle,
			    toggled = _props.toggled,
			    toggledColor = _props.toggledColor,
			    _onClick = _props.onClick,
			    disable = _props.disable;
			var _props2 = this.props,
			    bgColor = _props2.bgColor,
			    labelColor = _props2.labelColor;


			if (type === 'default') {
				labelColor = _colors.GREY900;
			} else {
				labelColor = _colors.GREY100;
			}

			if (this.state.random === null && this.props.isLoading) {
				this.setState({ random: this.generateLoadingAnimation() });
			}

			var styles = getStyles(this.props, this.state);

			switch (type) {
				case 'primary':
					bgColor = _colors.BLUE600;
					break;
				case 'danger':
					bgColor = _colors.RED600;
					break;
			}

			var nbgColor = toggle && this.state.toggled ? toggledColor ? toggledColor : (0, _colorManipulator.lighten)(bgColor, 0.2) : bgColor;

			nbgColor = this.state.hovered ? hoverColor ? hoverColor : (0, _colorManipulator.lighten)(nbgColor, 0.2) : nbgColor;

			if (this.state.isDown) {
				nbgColor = (0, _colorManipulator.darken)(nbgColor, 0.2);
			}

			var iconLeftStyle = Object.assign({}, styles.icon);

			var labelStyle = styles.label;

			var iconRightStyle = Object.assign({}, styles.icon);

			if (leftIcon && label) {
				iconLeftStyle['paddingRight'] = 5;
			}

			if (rightIcon && label) {
				iconRightStyle['paddingLeft'] = 5;
			}

			var leftElement = leftIcon ? _react2.default.createElement(
				'div',
				{ style: iconLeftStyle },
				_react2.default.cloneElement(leftIcon, { color: labelColor })
			) : null;
			var centerElement = _react2.default.createElement(
				'span',
				{ style: labelStyle },
				label
			);
			var rightElement = rightIcon ? _react2.default.createElement(
				'div',
				{ style: iconRightStyle },
				_react2.default.cloneElement(rightIcon, { color: labelColor })
			) : null;
			var loadingElement = this.props.isLoading ? _react2.default.createElement(
				'div',
				{ style: styles.loadingParent },
				_react2.default.createElement('div', { style: styles.loading })
			) : '';

			return _react2.default.createElement(
				_Paper2.default,
				{ style: Object.assign({}, styles.root, style), disable: disable, bgColor: nbgColor },
				_react2.default.createElement(
					'div',
					{ style: Object.assign({}, styles.button, styleButton),
						onMouseLeave: this.handleMouseLeave.bind(this),
						onMouseEnter: this.handleMouseEnter.bind(this),
						onMouseDown: function onMouseDown(e) {
							return _this2.setState({ isDown: true });
						},
						onMouseUp: function onMouseUp(e) {
							return _this2.setState({ isDown: false });
						},
						onClick: function onClick(e) {
							if (toggle) {
								_this2.setState({ toggled: !_this2.state.toggled });
							}
							if (_onClick) {
								_onClick(e);
							}
						} },
					_react2.default.createElement(
						'div',
						{ style: styles.item },
						leftElement,
						centerElement,
						rightElement
					)
				),
				loadingElement
			);
		}
	}]);

	return RaisedButton;
}(_react.Component);

RaisedButton.propTypes = {
	type: _react.PropTypes.oneOf(['default', 'primary', 'danger']),
	style: _react.PropTypes.object,
	styleButton: _react.PropTypes.object,
	bgColor: _react.PropTypes.string,
	hoverColor: _react.PropTypes.string,
	fullWidth: _react.PropTypes.bool,
	label: _react.PropTypes.string,
	labelColor: _react.PropTypes.string,
	size: _react.PropTypes.oneOf(['custom', 'large', 'small', 'mini']),
	fontSize: _react.PropTypes.number,
	fontFamily: _react.PropTypes.string,
	leftIcon: _react.PropTypes.node,
	rightIcon: _react.PropTypes.node,
	toggle: _react.PropTypes.bool,
	toggled: _react.PropTypes.bool,
	toggledColor: _react.PropTypes.string,
	onMouseDown: _react.PropTypes.func,
	onMouseUp: _react.PropTypes.func,
	onMouseEnter: _react.PropTypes.func,
	onMouseLeave: _react.PropTypes.func,
	onTouchEnd: _react.PropTypes.func,
	onTouchStart: _react.PropTypes.func,
	onClick: _react.PropTypes.func,
	disable: _react.PropTypes.bool,
	isLoading: _react.PropTypes.bool
};
RaisedButton.defaultProps = {
	type: 'default',
	size: 'custom',
	style: {},
	styleButton: {},
	bgColor: _colors.GREY100,
	fullWidth: false,
	label: 'Default',
	labelColor: _colors.GREY300,
	toggle: false,
	toggled: false,
	fontSize: _constants.FONT_SIZE_DEFAULT,
	fontFamily: _constants.FONT_FAMILY_DEFAULT,
	disable: false,
	isLoading: false
};
exports.default = RaisedButton;