'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ColorItem = require('./ColorItem');

var _ColorItem2 = _interopRequireDefault(_ColorItem);

var _GridList = require('./Grid/GridList');

var _GridList2 = _interopRequireDefault(_GridList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ColorGroup = function (_React$Component) {
  _inherits(ColorGroup, _React$Component);

  function ColorGroup(props) {
    _classCallCheck(this, ColorGroup);

    var _this = _possibleConstructorReturn(this, (ColorGroup.__proto__ || Object.getPrototypeOf(ColorGroup)).call(this, props));

    _this.state = {
      currentActiveIndex: props.activeIndex
    };
    return _this;
  }

  _createClass(ColorGroup, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(newProps) {
      if (newProps.activeIndex !== undefined) {
        this.state.currentActiveIndex = newProps.activeIndex;
      }
    }
  }, {
    key: 'renderList',
    value: function renderList() {
      var _this2 = this;

      return this.props.items.map(function (item, index) {
        return _react2.default.createElement(_ColorItem2.default, {
          key: index,
          defaultBgColor: item,
          onClick: function onClick(e, color) {
            var index = _this2.props.items.findIndex(function (c) {
              return c === color;
            });

            _this2.setState({ currentActiveIndex: index });

            if (_this2.props.onClick) {
              _this2.props.onClick(e, color, index);
            }
          },
          active: _this2.state.currentActiveIndex === index ? true : false,
          width: 28,
          height: 28,

          style: { marginTop: 5 }
        });
      });
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _GridList2.default,
        { cols: 10 },
        this.renderList()
      );
    }
  }]);

  return ColorGroup;
}(_react2.default.Component);

exports.default = ColorGroup;


ColorGroup.defaultProps = {
  items: _react2.default.PropTypes.array.isRequired,
  activeIndex: _react2.default.PropTypes.number
};