'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SvgIcon = require('./SvgIcon');

var _SvgIcon2 = _interopRequireDefault(_SvgIcon);

var _Navigation = require('../svgIcons/google/Navigation');

var _colors = require('../styles/colors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ColorItem = function (_React$Component) {
  _inherits(ColorItem, _React$Component);

  function ColorItem(props) {
    _classCallCheck(this, ColorItem);

    var _this = _possibleConstructorReturn(this, (ColorItem.__proto__ || Object.getPrototypeOf(ColorItem)).call(this, props));

    _this.state = {
      active: props.active
    };
    return _this;
  }

  _createClass(ColorItem, [{
    key: 'renderDisable',
    value: function renderDisable() {
      if (this.props.defaultBgColor === 'transparent') {
        return _react2.default.createElement(
          _SvgIcon2.default,
          { color: '#f00', style: {
              position: 'absolute',
              zIndex: -1,
              top: 0,
              left: 0,
              margin: this.props.width / 2 - 13 } },
          _react2.default.createElement('path', { d: 'M24,1.4L1.4,24L0,22.6L22.6,0L24,1.4z' })
        );
      }
    }
  }, {
    key: 'renderActive',
    value: function renderActive() {
      if (this.state.active) {
        return _react2.default.createElement(
          _SvgIcon2.default,
          { color: this.props.activeColor },
          _react2.default.createElement('path', { d: _Navigation.gCheck })
        );
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(newProps) {
      if (newProps.active !== undefined) {
        this.setState({ active: newProps.active });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        'div',
        {
          style: Object.assign({
            position: 'relative',
            width: this.props.width,
            height: this.props.height,
            borderRadius: 5,
            border: '1px solid',
            margin: 'auto',
            borderColor: this.state.active ? _colors.ORANGE700 : this.props.defaultColor,
            backgroundColor: this.props.defaultBgColor
          }, this.props.style),
          onClick: function onClick(e) {
            if (!_this2.state.active) {
              _this2.setState({ active: true });
            }

            if (_this2.props.onClick) {
              _this2.props.onClick(e, _this2.props.defaultBgColor);
            }
          }
        },
        this.renderDisable(),
        this.renderActive()
      );
    }
  }]);

  return ColorItem;
}(_react2.default.Component);

exports.default = ColorItem;


ColorItem.defaultProps = {
  width: 30,
  height: 30,
  defaultBgColor: '#fff',
  defaultColor: _colors.GREY300,
  activeColor: _colors.CYAN500,
  active: false,
  style: {}
};

ColorItem.propTypes = {
  width: _react2.default.PropTypes.number,
  height: _react2.default.PropTypes.number,
  defaultBgColor: _react2.default.PropTypes.string,
  defaultColor: _react2.default.PropTypes.string,
  activeColor: _react2.default.PropTypes.string,
  active: _react2.default.PropTypes.bool,
  onClick: _react2.default.PropTypes.func,
  style: _react2.default.PropTypes.object
};