'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _constants = require('../../styles/constants');

var _Is = require('../../utils/Is');

var _Is2 = _interopRequireDefault(_Is);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

require('../../csses/clearfix.css');

function getStyles(props) {
	return {
		root: {
			marginLeft: -props.gutter / 2,
			marginRight: -props.gutter / 2
		},

		item: {
			float: 'left',
			boxSizing: 'border-box',
			paddingLeft: props.gutter / 2,
			paddingRight: props.gutter / 2
		}
	};
}

var GridList = function (_Component) {
	_inherits(GridList, _Component);

	function GridList() {
		_classCallCheck(this, GridList);

		return _possibleConstructorReturn(this, (GridList.__proto__ || Object.getPrototypeOf(GridList)).apply(this, arguments));
	}

	_createClass(GridList, [{
		key: 'render',
		value: function render() {

			var styles = getStyles(this.props);

			var _props = this.props,
			    children = _props.children,
			    cols = _props.cols,
			    center = _props.center;


			if (!(0, _Is2.default)(children, 'Array')) {
				children = [children];
			}

			var wrappedChildren = children.map(function (child, index) {
				var itemStyle = Object.assign({}, styles.item, {
					width: 100 / cols + '%',
					textAlign: center ? 'center' : 'left'
				});
				return _react2.default.createElement(
					'div',
					{ key: 'grid_' + index, style: Object.assign({}, itemStyle) },
					child
				);
			});

			return _react2.default.createElement(
				'div',
				{ style: { overflow: 'hidden' } },
				_react2.default.createElement(
					'div',
					{ style: Object.assign({}, styles.root, this.props.style), className: 'clearfix' },
					wrappedChildren,
					_react2.default.createElement('div', { style: { clear: 'both' } })
				)
			);
		}
	}]);

	return GridList;
}(_react.Component);

GridList.propTypes = {
	children: _react.PropTypes.node,
	center: _react.PropTypes.bool,
	cols: _react.PropTypes.number,
	gutter: _react.PropTypes.number,
	style: _react.PropTypes.object
};
GridList.defaultProps = {
	cols: 2,
	center: false,
	gutter: _constants.GUTTER
};
exports.default = GridList;