'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _colors = require('../styles/colors');

var _SvgIcon = require('./SvgIcon');

var _SvgIcon2 = _interopRequireDefault(_SvgIcon);

var _Action = require('../svgIcons/google/Action');

var _Content = require('../svgIcons/google/Content');

var _Editor = require('../svgIcons/google/Editor');

var _Hardware = require('../svgIcons/google/Hardware');

var _Image = require('../svgIcons/google/Image');

var _Navigation = require('../svgIcons/google/Navigation');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var name2Icon = {
    // Action
    gLock: _Action.gLock,
    gLockOpen: _Action.gLockOpen,
    gLockOutline: _Action.gLockOutline,
    gVisibility: _Action.gVisibility,
    gVisibilityOff: _Action.gVisibilityOff,
    gHighlightOff: _Action.gHighlightOff,
    gHelp: _Action.gHelp,
    gHelpOutline: _Action.gHelpOutline,
    gDelete: _Action.gDelete,
    gDeleteForever: _Action.gDeleteForever,
    gBuild: _Action.gBuild,
    // Content
    gClear: _Content.gClear,
    gAddCircle: _Content.gAddCircle,
    gRemoveCircle: _Content.gRemoveCircle,
    gUndo: _Content.gUndo,
    gRedo: _Content.gRedo,
    // Editor
    gTitle: _Editor.gTitle,
    // Hardware
    gKeyboardArrowDown: _Hardware.gKeyboardArrowDown,
    gKeyboardArrowRight: _Hardware.gKeyboardArrowRight,
    gKeyboardArrowLeft: _Hardware.gKeyboardArrowLeft,
    gKeyboardArrowUp: _Hardware.gKeyboardArrowUp,
    // Image
    gImage: _Image.gImage,
    gDehaze: _Image.gDehaze,
    gTransform: _Image.gTransform,
    gBrush: _Image.gBrush,
    // Navigation
    gCheck: _Navigation.gCheck,
    gArrowBack: _Navigation.gArrowBack,
    gArrowDownward: _Navigation.gArrowDownward,
    gArrowForward: _Navigation.gArrowForward,
    gArrowUpward: _Navigation.gArrowUpward,
    gCancel: _Navigation.gCancel
};

function getStyles(props) {
    return {
        root: {
            margin: 0,
            padding: 0,
            verticalAlign: 'middle',
            display: 'inline-block',
            fill: props.color,
            height: props.height || 24,
            width: props.width || 24,
            userSelect: 'none'
        }
    };
}

var Icon = function (_Component) {
    _inherits(Icon, _Component);

    function Icon() {
        _classCallCheck(this, Icon);

        return _possibleConstructorReturn(this, (Icon.__proto__ || Object.getPrototypeOf(Icon)).apply(this, arguments));
    }

    _createClass(Icon, [{
        key: 'render',
        value: function render() {
            var styles = getStyles(this.props);
            return _react2.default.createElement(
                _SvgIcon2.default,
                {
                    viewBox: this.props.viewBox,
                    style: Object.assign({}, styles.root, this.props.style) },
                _react2.default.createElement('path', { d: name2Icon[this.props.type] })
            );
        }
    }]);

    return Icon;
}(_react.Component);

Icon.propTypes = {
    children: _react.PropTypes.node,
    color: _react.PropTypes.string,
    width: _react.PropTypes.number,
    height: _react.PropTypes.number,
    viewBox: _react.PropTypes.string,
    type: _react.PropTypes.string.isRequired,
    style: _react.PropTypes.object
};
Icon.defaultProps = {
    color: _colors.GREY100,
    viewBox: '0 0 24 24'
};
exports.default = Icon;