'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _colors = require('../styles/colors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Input = function (_Component) {
    _inherits(Input, _Component);

    function Input(props) {
        _classCallCheck(this, Input);

        var _this = _possibleConstructorReturn(this, (Input.__proto__ || Object.getPrototypeOf(Input)).call(this, props));

        _this.state = {
            active: false
        };
        // console.log(this.state); //
        return _this;
    }

    _createClass(Input, [{
        key: 'onHandleChange',
        value: function onHandleChange(event) {
            var val = event.target.value;
            // console.log(val);
            this.setState({ value: val });

            if (this.props.onChange) {
                this.props.onChange(event, val);
            }
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(newProps) {
            if (newProps.value !== undefined) {
                this.setState({
                    value: newProps.value
                });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var defaultBorderColor = _colors.GREY300,
                activeBorderColor = _colors.CYAN500;

            var style = {
                boxSizing: 'border-box',
                color: this.state.active ? _colors.CYAN500 : _colors.GREY500,
                border: 'none',
                borderBottom: 'solid',
                borderWidth: this.state.active ? 2 : 1,
                borderColor: this.state.active ? activeBorderColor : defaultBorderColor,
                minHeight: 20,
                height: this.props.height,
                width: '100%',
                outline: 'none'
            };
            // console.log(this);
            return _react2.default.createElement('input', {
                style: Object.assign(style, this.props.style),
                placeholder: this.props.placeholder,
                value: this.props.value,
                onFocus: function onFocus(e) {
                    return _this2.setState({ active: true });
                },
                onBlur: function onBlur(e) {
                    return _this2.setState({ active: false });
                },
                onChange: this.onHandleChange.bind(this)
            });
        }
    }]);

    return Input;
}(_react.Component);

Input.propTypes = {
    placeholder: _react.PropTypes.string,
    height: _react.PropTypes.number,
    value: _react.PropTypes.any,
    onChange: _react.PropTypes.func,
    style: _react.PropTypes.object
};
Input.defaultProps = {
    placeholder: '',
    height: 20,
    style: {}
};
exports.default = Input;