'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Input = require('./Input');

var _Input2 = _interopRequireDefault(_Input);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InputNumber = function (_Component) {
    _inherits(InputNumber, _Component);

    function InputNumber(props) {
        _classCallCheck(this, InputNumber);

        var _this = _possibleConstructorReturn(this, (InputNumber.__proto__ || Object.getPrototypeOf(InputNumber)).call(this, props));

        _this.state = {
            value: props.value
        };
        return _this;
    }

    _createClass(InputNumber, [{
        key: 'onHandleChange',
        value: function onHandleChange(event) {
            var val = event.target.value,
                _vals = [];

            if (val == '') {
                val = '0';
            }

            if (this.props.type === 'INT') {

                val = val.replace(/[^0-9\-]/g, '');
                var isNegative = false;
                // remove - (ex before)
                var _val = val.replace(/\-/g, '');
                if (val[0] === '-') {
                    isNegative = true;
                }

                var isAdd = false;
                var isZero = true;
                for (var i = 0; i < _val.length; i++) {
                    if (!isAdd && _val[i] != 0) {
                        isAdd = true;
                        isZero = false;
                    }

                    if (isAdd) {
                        _vals.push(_val[i]);
                    }
                }
                // console.log()
                if (isZero && _val.length > 0) {
                    _vals.push(0);
                } else {
                    if (isNegative) {
                        // 插入负号
                        _vals.splice(0, 0, '-');
                    }
                }
            } else if (this.props.type === 'NUMBER') {

                val = val.replace(/[^0-9\.\-]/g, '');

                // remove - (ex before)
                var _val2 = val.replace(/\-/g, '');
                if (val[0] === '-') {
                    _val2 = '-' + _val2;
                }

                // remove . (only one)
                var isDot = false;
                for (var _i = 0; _i < _val2.length; _i++) {
                    if (_val2[_i] === '.') {
                        if (!isDot) {
                            _vals.push(_val2[_i]);
                            isDot = true;
                        }
                    } else {
                        _vals.push(_val2[_i]);
                    }
                }
            } else {
                // todo
            }

            var ovalue = parseFloat(_vals.join(''));

            this.setState({ value: ovalue });

            if (ovalue == this.state.value) {
                return;
            }

            if (this.props.onChange) {
                this.props.onChange(event, ovalue);
            }
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(newProps) {
            if (newProps.value !== undefined) {
                this.setState({
                    value: newProps.value
                });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(_Input2.default, {
                value: this.state.value,
                onChange: this.onHandleChange.bind(this),
                style: this.props.style
            });
        }
    }]);

    return InputNumber;
}(_react.Component);

InputNumber.propTypes = {
    type: _react.PropTypes.oneOf(['INT', 'NUMBER']),
    value: _react.PropTypes.number,
    onChange: _react.PropTypes.func,
    style: _react.PropTypes.object
};
InputNumber.defaultProps = {
    value: 0,
    type: 'NUMBER',
    floatingLabelText: '',
    style: {}
};
exports.default = InputNumber;