'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _InputNumber = require('./InputNumber');

var _InputNumber2 = _interopRequireDefault(_InputNumber);

var _Slider = require('./Slider');

var _Slider2 = _interopRequireDefault(_Slider);

var _colors = require('../styles/colors');

var _SetToRange = require('../utils/SetToRange');

var _SetToRange2 = _interopRequireDefault(_SetToRange);

var _constants = require('../styles/constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getStyles(props) {
	var height = props.height,
	    dotRadius = props.dotRadius,
	    label = props.label,
	    labelWidth = props.labelWidth,
	    inputWidth = props.inputWidth,
	    labelColor = props.labelColor,
	    labelFontSize = props.labelFontSize,
	    labelFontFamily = props.labelFontFamily;

	var gutter = 5;
	// const height = dotRadius * 2;
	return {
		root: {
			position: 'relative',
			// backgroundColor: '#f00',
			height: height
		},
		label: {
			position: 'absolute',
			left: 0,
			top: 0,
			bottom: 0,
			// backgroundColor: '#ff0',
			verticalAlign: 'middle',
			height: height,
			lineHeight: height + 'px',
			margin: 'auto',
			width: labelWidth,
			color: labelColor,
			fontSize: labelFontSize,
			fontFamily: labelFontFamily
		},
		input: {
			overflow: 'hidden',
			position: 'absolute',
			left: label ? labelWidth + gutter : 0,
			top: 0,
			width: inputWidth,
			height: height
		},
		slider: {
			position: 'absolute',
			top: height / 2 - dotRadius,
			left: label ? labelWidth + inputWidth + gutter * 2 : inputWidth + gutter,
			right: 0
		}
	};
}

var InputNumberSlider = function (_Component) {
	_inherits(InputNumberSlider, _Component);

	function InputNumberSlider(props) {
		_classCallCheck(this, InputNumberSlider);

		var _this = _possibleConstructorReturn(this, (InputNumberSlider.__proto__ || Object.getPrototypeOf(InputNumberSlider)).call(this, props));

		_this.state = {
			value: props.defaultValue
		};
		return _this;
	}

	_createClass(InputNumberSlider, [{
		key: 'init',
		value: function init(props) {
			var value = props.value;
			if (value === undefined) {
				value = props.defaultValue !== undefined ? props.defaultValue : props.min;
			}

			var halfHeight = props.height / 2;
			if (props.dotRadius > halfHeight) {
				throw new Error('props.dotRadius 不能大于 props.height / 2.');
			}

			this.setState({ value: value });
		}
	}, {
		key: 'componentWillMount',
		value: function componentWillMount() {
			this.init(this.props);
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(newProps) {
			this.init(newProps);
			// if(newProps.defaultValue !== undefined) {
			// 	this.setState({
			// 		value: newProps.defaultValue
			// 	});
			// }
		}
	}, {
		key: 'onSliderHandleChange',
		value: function onSliderHandleChange(event, value) {
			this.setState({ value: value });

			if (this.props.onChange) {
				this.props.onChange(event, value);
			}
		}
	}, {
		key: 'onInputHandleChange',
		value: function onInputHandleChange(event, value) {
			// value = parseFloat(event.target.value);
			this.setState({ value: value });

			if (this.props.onChange) {
				this.props.onChange(event, value);
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    height = _props.height,
			    dotRadius = _props.dotRadius,
			    label = _props.label,
			    min = _props.min,
			    max = _props.max,
			    type = _props.type;


			var sliderValue = (0, _SetToRange2.default)(this.state.value, min, max);

			var styles = getStyles(this.props);
			var labelDiv = label ? _react2.default.createElement(
				'div',
				{ style: styles.label },
				label
			) : '';
			return _react2.default.createElement(
				'div',
				{ style: styles.root },
				labelDiv,
				_react2.default.createElement(
					'div',
					{ style: styles.input },
					_react2.default.createElement(_InputNumber2.default, {
						style: { height: height },
						value: Number(this.state.value.toFixed(this.props.fixed)),
						onChange: this.onInputHandleChange.bind(this),
						type: type })
				),
				_react2.default.createElement(_Slider2.default, {
					dotRadius: dotRadius,
					value: sliderValue,
					onChange: this.onSliderHandleChange.bind(this),
					max: max,
					min: min,
					step: type === 'INT' ? 1 : 0.01,
					style: styles.slider })
			);
		}
	}]);

	return InputNumberSlider;
}(_react.Component);

InputNumberSlider.defaultProps = {
	height: 30,
	dotRadius: 6,
	fixed: 2,
	type: 'NUMBER',
	labelColor: _colors.GREY500,
	labelFontSize: _constants.FONT_SIZE_SMALL,
	labelFontFamily: _constants.FONT_FAMILY_DEFAULT,
	labelWidth: 30,
	inputWidth: 55,
	defaultValue: 0,
	max: 10,
	min: 0
};
InputNumberSlider.propTypes = {
	height: _react.PropTypes.number,
	dotRadius: _react.PropTypes.number,
	fixed: _react.PropTypes.number,
	label: _react.PropTypes.string,
	labelColor: _react.PropTypes.string,
	labelFontSize: _react.PropTypes.number,
	labelFontFamily: _react.PropTypes.string,
	labelWidth: _react.PropTypes.number,
	inputWidth: _react.PropTypes.number,
	onChange: _react.PropTypes.func,
	defaultValue: _react.PropTypes.number,
	value: _react.PropTypes.number,
	type: _react.PropTypes.oneOf(['INT', 'NUMBER']),
	max: _react.PropTypes.number,
	min: _react.PropTypes.number
};
exports.default = InputNumberSlider;