'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _InputNumberSlider = require('./InputNumberSlider');

var _InputNumberSlider2 = _interopRequireDefault(_InputNumberSlider);

var _VerticalSeparation = require('./VerticalSeparation');

var _VerticalSeparation2 = _interopRequireDefault(_VerticalSeparation);

var _SvgIcon = require('./SvgIcon');

var _SvgIcon2 = _interopRequireDefault(_SvgIcon);

var _IconButton = require('./Button/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _SetToRange = require('../utils/SetToRange');

var _SetToRange2 = _interopRequireDefault(_SetToRange);

var _colors = require('../styles/colors');

var _constants = require('../styles/constants');

var _Action = require('../svgIcons/google/Action');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var lockColor = _colors.CYAN500;

var unLockColor = _colors.GREY500;

var lockIconPath = _react2.default.createElement('path', { d: _Action.gLock });

var unLockIconPath = _react2.default.createElement('path', { d: _Action.gLockOpen });

function getStyles(props, state) {
	var defaults = props.defaults,
	    cellHeight = props.cellHeight,
	    gutterY = props.gutterY,
	    iconSize = props.iconSize,
	    title = props.title,
	    titleWidth = props.titleWidth,
	    titleColor = props.titleColor,
	    titleFontSize = props.titleFontSize,
	    titleFontFamily = props.titleFontFamily;


	var count = defaults.length;
	var height = count * cellHeight + gutterY * (count - 1);
	var borderColor = state.lock ? lockColor : unLockColor;
	var gutter = 5;
	return {
		root: {
			position: 'relative',
			height: height
		},
		title: {
			position: 'absolute',
			left: 0,
			top: 0,
			bottom: 0,
			// backgroundColor: '#ff0',
			verticalAlign: 'middle',
			height: height,
			lineHeight: height + 'px',
			margin: 'auto',
			width: titleWidth,
			color: titleColor,
			fontSize: titleFontSize,
			fontFamily: titleFontFamily
		},
		slider: {
			position: 'absolute',
			left: title ? titleWidth : 0,
			top: 0,
			right: 25
		},
		icon: {
			position: 'absolute',
			backgroundColor: '#fff',
			height: iconSize + 2,
			top: (height - iconSize - 6) / 2,
			right: 0
		},
		line: {
			boxSizing: 'border-box',
			position: 'absolute',
			top: cellHeight / 2,
			bottom: cellHeight / 2,
			right: iconSize / 2,
			width: 3,

			borderColor: borderColor,
			borderStyle: 'solid',
			borderTopWidth: 1,
			borderRightWidth: 1,
			borderLeftWidth: 0,
			borderBottomWidth: 1
			// borderTopRightRadius: 5
		}
	};
}

var InputNumberSliderGroup = function (_Component) {
	_inherits(InputNumberSliderGroup, _Component);

	function InputNumberSliderGroup(props) {
		_classCallCheck(this, InputNumberSliderGroup);

		var _this = _possibleConstructorReturn(this, (InputNumberSliderGroup.__proto__ || Object.getPrototypeOf(InputNumberSliderGroup)).call(this, props));

		_this.onIconClick = function () {
			_this.setState({ lock: !_this.state.lock });
		};

		_this.state = {
			lock: props.lock,
			values: props.defaults
		};
		return _this;
	}

	_createClass(InputNumberSliderGroup, [{
		key: 'renderItems',
		value: function renderItems() {
			var _this2 = this;

			var _state = this.state,
			    lock = _state.lock,
			    values = _state.values;
			var _props = this.props,
			    cellHeight = _props.cellHeight,
			    max = _props.max,
			    min = _props.min,
			    type = _props.type,
			    labels = _props.labels,
			    labelWidth = _props.labelWidth,
			    labelColor = _props.labelColor,
			    _onChange = _props.onChange;

			return values.map(function (value, index) {
				var label = labels && labels.length > index ? labels[index] : undefined;
				return _react2.default.createElement(_InputNumberSlider2.default, {
					onChange: function onChange(e, v) {
						var newValues = void 0;
						if (lock) {
							var scale = (v - value) / (max - min);
							newValues = [].concat(_toConsumableArray(values));

							for (var i = 0; i < newValues.length; i++) {
								newValues[i] += scale * (max - min);

								// newValues[i] = SetToRange(newValues[i], min, max);
							}

							_this2.setState({ values: newValues });
						} else {
							newValues = [].concat(_toConsumableArray(values));
							newValues[index] = v;
							_this2.setState({ values: newValues });
						}

						if (_onChange) {
							_onChange(e, newValues);
						}
					},
					label: label,
					type: type,
					labelWidth: labelWidth,
					labelColor: labelColor,
					cellHeight: cellHeight,
					key: 'inputNumberSliderGroup_' + index,
					max: max, min: min,
					defaultValue: value });
			});
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(newProps) {
			if (newProps.defaults !== undefined) {
				this.setState({
					values: newProps.defaults
				});
			}
			// if(newProps.lock !== undefined) {
			// 	this.setState({
			// 		lock: newProps.lock
			// 	});
			// }
		}
	}, {
		key: 'render',
		value: function render() {
			var _props2 = this.props,
			    iconSize = _props2.iconSize,
			    gutterY = _props2.gutterY,
			    title = _props2.title;


			var mstyle = {
				paddingBottom: 2,
				backgroundColor: '#fff'
			};

			var icon = this.state.lock ? _react2.default.createElement(_IconButton2.default, {
				padding: 0,
				color: lockColor,
				onClick: this.onIconClick,
				style: mstyle,
				icon: _react2.default.createElement(
					_SvgIcon2.default,
					{
						width: iconSize,
						height: iconSize },
					lockIconPath
				) }) : _react2.default.createElement(_IconButton2.default, {
				padding: 0,
				color: unLockColor,
				onClick: this.onIconClick,
				style: mstyle,
				icon: _react2.default.createElement(
					_SvgIcon2.default,
					{
						width: iconSize,
						height: iconSize,
						onClick: this.onIconClick },
					unLockIconPath
				) });

			var styles = getStyles(this.props, this.state);

			var titleDiv = title ? _react2.default.createElement(
				'div',
				{ style: styles.title },
				title
			) : '';
			return _react2.default.createElement(
				'div',
				{ style: styles.root },
				titleDiv,
				_react2.default.createElement(
					'div',
					{ style: styles.slider },
					_react2.default.createElement(
						_VerticalSeparation2.default,
						{ gutter: gutterY },
						this.renderItems()
					)
				),
				_react2.default.createElement('div', { style: styles.line }),
				_react2.default.createElement(
					'div',
					{ style: styles.icon },
					icon
				)
			);
		}
	}]);

	return InputNumberSliderGroup;
}(_react.Component);

InputNumberSliderGroup.propTypes = {
	gutterY: _react.PropTypes.number,
	cellHeight: _react.PropTypes.number,
	type: _react.PropTypes.oneOf(['INT', 'NUMBER']),
	iconSize: _react.PropTypes.number,
	defaults: _react.PropTypes.arrayOf(_react.PropTypes.number).isRequired,
	title: _react.PropTypes.string,
	titleWidth: _react.PropTypes.number,
	titleColor: _react.PropTypes.string,
	labels: _react.PropTypes.arrayOf(_react.PropTypes.string),
	labelWidth: _react.PropTypes.number,
	labelColor: _react.PropTypes.string,
	onChange: _react.PropTypes.func,
	max: _react.PropTypes.number.isRequired,
	min: _react.PropTypes.number.isRequired
};
InputNumberSliderGroup.defaultProps = {
	gutterY: 5,
	iconSize: 16,
	labelWidth: 10,
	cellHeight: 30,
	titleWidth: 50,
	titleColor: _colors.GREY500,
	titleFontSize: _constants.FONT_SIZE_DEFAULT,
	titleFontFamily: _constants.FONT_FAMILY_DEFAULT,
	type: 'NUMBER'
};
exports.default = InputNumberSliderGroup;