'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _constants = require('../styles/constants');

var _colors = require('../styles/colors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Label = function (_Component) {
	_inherits(Label, _Component);

	function Label() {
		_classCallCheck(this, Label);

		return _possibleConstructorReturn(this, (Label.__proto__ || Object.getPrototypeOf(Label)).apply(this, arguments));
	}

	_createClass(Label, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    content = _props.content,
			    fontSize = _props.fontSize,
			    fontFamily = _props.fontFamily,
			    color = _props.color,
			    height = _props.height,
			    style = _props.style;


			var parentStyle = {
				display: 'table',
				height: height
			};

			var defaultStyle = {
				display: 'table-cell',
				verticalAlign: 'middle',
				color: color,
				fontSize: fontSize,
				fontFamily: fontFamily,
				whiteSpace: 'nowrap' // 强制不换行
			};

			return _react2.default.createElement(
				'div',
				{ style: { display: 'inline-block', height: height } },
				_react2.default.createElement(
					'div',
					{ style: parentStyle },
					_react2.default.createElement(
						'span',
						{ style: Object.assign({}, defaultStyle, style) },
						content
					)
				)
			);
		}
	}]);

	return Label;
}(_react.Component);

Label.propTypes = {
	content: _react.PropTypes.string,
	fontSize: _react.PropTypes.number,
	fontFamily: _react.PropTypes.string,
	color: _react.PropTypes.string,
	height: _react.PropTypes.number,
	style: _react.PropTypes.object
};
Label.defaultProps = {
	content: 'Label',
	fontSize: _constants.FONT_SIZE_DEFAULT,
	fontFamily: _constants.FONT_FAMILY_DEFAULT,
	color: _colors.GREY500,
	height: 20,
	style: {}
};
exports.default = Label;