'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _colors = require('../styles/colors');

var _constants = require('../styles/constants');

var _colorManipulator = require('../utils/colorManipulator');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getStyles(props) {
	return {
		root: {
			listStyle: 'none',
			margin: 0,
			padding: 0
		},

		item: {
			padding: 10,
			color: props.color,
			fontFamily: props.fontFamily,
			fontSize: props.fontSize,
			margin: props.gutter,
			position: 'relative'
		},

		itemLeft: {
			position: 'absolute',
			left: 10,
			top: 0,
			bottom: 0,
			height: 24,
			margin: 'auto'
		},

		itemCenter: {},

		itemRight: {
			position: 'absolute',
			right: 10,
			top: 0,
			bottom: 0,
			height: 24,
			margin: 'auto'
		}
	};
}

var List = function (_Component) {
	_inherits(List, _Component);

	function List(props) {
		_classCallCheck(this, List);

		var _this = _possibleConstructorReturn(this, (List.__proto__ || Object.getPrototypeOf(List)).call(this, props));

		_this.dragStart = function (e) {
			_this.dragged = e.currentTarget;

			e.dataTransfer.effectAllowed = 'move';

			// Firefox requires calling dataTransfer.setData
			// for the drag to properly work
			e.dataTransfer.setData('text/html', e.currentTarget);
		};

		_this.dragEnd = function (e) {
			_this.dragged.style.display = 'block';
			_this.dragged.parentNode.removeChild(_this.placeholder);

			// Update state
			var items = _this.state.items;
			var from = Number(_this.dragged.dataset.id);
			var to = Number(_this.over.dataset.id);
			if (from < to) {
				to--;
			}

			items.splice(to, 0, items.splice(from, 1)[0]);
			_this.setState({ items: items, hoverIndex: to, activeIndex: to });
		};

		_this.dragOver = function (e) {
			e.preventDefault();
			if (e.target.tagName !== 'LI') {
				return;
			}
			_this.dragged.style.display = 'none';
			_this.over = e.target;
			e.target.parentNode.insertBefore(_this.placeholder, e.target);
		};

		_this.state = {
			items: props.items,
			hoverIndex: -1,
			activeIndex: props.activeIndex
		};

		_this.placeholder = document.createElement('li');
		_this.placeholder.style.height = '40px';
		_this.placeholder.style.boxSizing = 'border-box';
		_this.placeholder.style.margin = props.gutter + 'px';
		_this.placeholder.style.border = '2px dashed ' + _colors.CYAN200;
		return _this;
	}

	_createClass(List, [{
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(newProps) {
			if (newProps.items !== undefined) {
				this.setState({
					items: newProps.items
				});
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    style = _props.style,
			    itemStyle = _props.itemStyle,
			    color = _props.color,
			    bgColor = _props.bgColor,
			    hoverColor = _props.hoverColor,
			    activeColor = _props.activeColor,
			    _onMouseEnter = _props.onMouseEnter,
			    _onMouseLeave = _props.onMouseLeave,
			    _onClick = _props.onClick;


			var styles = getStyles(this.props);
			return _react2.default.createElement(
				'ul',
				{ style: Object.assign(styles.root, style) },
				this.state.items.map(function (item, index) {
					var backgroundColor = bgColor;

					if (index === _this2.state.activeIndex) {
						if (activeColor) {
							backgroundColor = activeColor;
						}
					}

					if (index === _this2.state.hoverIndex) {
						backgroundColor = hoverColor ? backgroundColor : (0, _colorManipulator.darken)(backgroundColor, 0.1);
					}

					var centerStyle = {};

					var leftElement = '',
					    rightElement = '';
					// console.log(item.left, item.title);
					if (item.left) {
						centerStyle.marginLeft = 30;
						var leftCloned = _react2.default.cloneElement(item.left, {
							padding: 0,
							color: color
						});
						leftElement = _react2.default.createElement(
							'div',
							{ style: styles.itemLeft },
							leftCloned
						);
					}

					var centerElement = _react2.default.createElement(
						'div',
						{ style: centerStyle },
						item.title
					);

					if (item.right) {
						var rightCloned = _react2.default.cloneElement(item.right, {
							padding: 0,
							color: color
						});
						rightElement = _react2.default.createElement(
							'div',
							{ style: styles.itemRight },
							rightCloned
						);
					}

					return _react2.default.createElement(
						'li',
						{ key: item.title + '_' + index,
							'data-id': index,
							style: Object.assign({}, styles.item, itemStyle, { backgroundColor: backgroundColor }),
							draggable: 'true',
							onDragEnd: _this2.dragEnd,
							onDragStart: _this2.dragStart,
							onDragOver: _this2.dragOver,
							onMouseLeave: function onMouseLeave(e) {
								_this2.setState({ hoverIndex: -1 });
								if (_onMouseLeave) {
									_onMouseLeave(e, item.title, index);
								}
							},
							onMouseEnter: function onMouseEnter(e) {
								_this2.setState({ hoverIndex: index });
								if (_onMouseEnter) {
									_onMouseEnter(e, item.title, index);
								}
							},
							onClick: function onClick(e) {
								_this2.setState({ activeIndex: index });
								if (_onClick) {
									_onClick(e, item.title, index);
								}
							} },
						_react2.default.createElement(
							'div',
							null,
							leftElement,
							centerElement,
							rightElement
						)
					);
				})
			);
		}
	}]);

	return List;
}(_react.Component);

List.propsTypes = {
	items: _react.PropTypes.arrayOf(_react.PropTypes.objectOf({
		left: _react.PropTypes.node,
		title: _react.PropTypes.string,
		right: _react.PropTypes.node
	})),
	style: _react.PropTypes.object,
	itemStyle: _react.PropTypes.object,
	color: _react.PropTypes.string,
	bgColor: _react.PropTypes.string,
	hoverColor: _react.PropTypes.string,
	activeColor: _react.PropTypes.string,
	onMouseLeave: _react.PropTypes.func,
	onMouseEnterv: _react.PropTypes.func,
	onClick: _react.PropTypes.func,
	gutter: _react.PropTypes.number,
	fontSize: _react.PropTypes.number,
	fontFamily: _react.PropTypes.string,
	activeIndex: _react.PropTypes.number
};
List.defaultProps = {
	color: _colors.GREY600,
	bgColor: _colors.GREY300,
	activeColor: _colors.CYAN200,
	fontSize: _constants.FONT_SIZE_DEFAULT,
	fontFamily: _constants.FONT_FAMILY_DEFAULT,
	gutter: _constants.GUTTER,
	activeIndex: -1
};
exports.default = List;