'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _GridList = require('../Grid/GridList');

var _GridList2 = _interopRequireDefault(_GridList);

var _Label = require('../Label');

var _Label2 = _interopRequireDefault(_Label);

var _colors = require('../../styles/colors.js');

var _constants = require('../../styles/constants');

var _Left = require('../Left');

var _Left2 = _interopRequireDefault(_Left);

var _cloneElements = require('./cloneElements');

var _cloneElements2 = _interopRequireDefault(_cloneElements);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Menu = function (_Component) {
	_inherits(Menu, _Component);

	function Menu(props) {
		_classCallCheck(this, Menu);

		var _this = _possibleConstructorReturn(this, (Menu.__proto__ || Object.getPrototypeOf(Menu)).call(this, props));

		_this.state = {
			activeLevelIndex: props.activeLevelIndex,
			activeParentIndex: props.activeParentIndex,
			activeMemberIndex: props.activeMemberIndex
		};

		_this.type = 'Menu';
		return _this;
	}

	_createClass(Menu, [{
		key: 'getChildContext',
		value: function getChildContext() {
			return {
				component: this
			};
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    children = _props.children,
			    bgColor = _props.bgColor;
			var _props2 = this.props,
			    mode = _props2.mode,
			    theme = _props2.theme;


			if (theme === 'dark') {
				bgColor = _colors.GREY800;
			} else if (theme === 'light') {
				bgColor = _colors.GREY100;
			}

			var rootStyle = {
				backgroundColor: bgColor
			};

			var _children = (0, _cloneElements2.default)(children);

			var PCMenuBar = _react2.default.createElement(
				_Left2.default,
				{ style: rootStyle },
				_children
			);
			if (mode === 'vertical') {
				PCMenuBar = _react2.default.createElement(
					'div',
					{ style: Object.assign({}, rootStyle, {
							display: 'inline-block'
						}) },
					_children
				);
			}

			return PCMenuBar;
		}
	}]);

	return Menu;
}(_react.Component);

Menu.propTypes = {
	mode: _react.PropTypes.oneOf(['horizontal', 'vertical']),
	theme: _react.PropTypes.oneOf(['dark', 'light', 'custom']),
	children: _react.PropTypes.node,
	bgColor: _react.PropTypes.string,
	activeLevelIndex: _react.PropTypes.number,
	activeParentIndex: _react.PropTypes.number,
	activeMemberIndex: _react.PropTypes.number,
	itemHeight: _react.PropTypes.number,
	subBgColor: _react.PropTypes.string,
	itemActiveBgColor: _react.PropTypes.string,
	itemColor: _react.PropTypes.string,
	itemFontFamily: _react.PropTypes.string,
	itemFontSize: _react.PropTypes.number,
	itemPadding: _react.PropTypes.number
};
Menu.defaultProps = {
	mode: 'horizontal',
	theme: 'dark',
	activeLevelIndex: -1,
	activeParentIndex: -1,
	activeMemberIndex: -1,
	bgColor: _colors.GREY800,
	subBgColor: _colors.GREY900,
	itemHeight: 36,
	itemActiveBgColor: _colors.BLUE600,
	itemColor: _colors.GREY300,
	itemFontFamily: _constants.FONT_FAMILY_DEFAULT,
	itemFontSize: _constants.FONT_SIZE_DEFAULT,
	itemPadding: 20

};
Menu.childContextTypes = {
	component: _react.PropTypes.any
};
exports.default = Menu;