'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _MixinComponent2 = require('./MixinComponent');

var _MixinComponent3 = _interopRequireDefault(_MixinComponent2);

var _Label = require('../Label');

var _Label2 = _interopRequireDefault(_Label);

var _VerticalMiddle = require('../VerticalMiddle');

var _VerticalMiddle2 = _interopRequireDefault(_VerticalMiddle);

var _Left = require('../Left');

var _Left2 = _interopRequireDefault(_Left);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MenuItem = function (_MixinComponent) {
	_inherits(MenuItem, _MixinComponent);

	function MenuItem(props) {
		_classCallCheck(this, MenuItem);

		var _this = _possibleConstructorReturn(this, (MenuItem.__proto__ || Object.getPrototypeOf(MenuItem)).call(this, props));

		_this.state = {
			active: false,
			hover: false
		};

		_this.type = 'MenuItem';
		return _this;
	}

	_createClass(MenuItem, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    label = _props.label,
			    children = _props.children,
			    _onClick = _props.onClick,
			    icon = _props.icon;


			var menuProps = this.getMenuProps();
			var rootMenu = menuProps.component;

			var height = menuProps.itemHeight;
			var activeBgColor = menuProps.itemActiveBgColor;
			var textColor = menuProps.itemColor;
			var fontFamily = menuProps.itemFontFamily;
			var fontSize = menuProps.itemFontSize;
			var padding = menuProps.itemPadding;

			var index = menuProps.index;

			var iconSize = fontSize + 4;
			var iconStyle = {
				margin: (height - iconSize) / 2,
				marginRight: 5,
				marginLeft: 0
			};

			var parentIndex = this.parent().props.selfIndex;
			if (parentIndex === undefined) parentIndex = 0;

			// 左边的图标
			var iconElement = icon !== undefined ? _react2.default.createElement(
				_VerticalMiddle2.default,
				{ height: height },
				_react2.default.cloneElement(icon, { color: textColor, width: iconSize, height: iconSize, style: iconStyle })
			) : '';

			// 查看是否处于激活状态
			var isActive = rootMenu.state.activeLevelIndex == index - 1 && rootMenu.state.activeParentIndex == parentIndex && rootMenu.state.activeMemberIndex == this.props.selfIndex;

			return _react2.default.createElement(
				'div',
				{ style: {
						boxSizing: 'border-box',
						backgroundColor: isActive ? activeBgColor : 'transparent',
						borderBottom: '2px solid ' + (rootMenu.props.mode === 'horizontal' && this.state.hover ? activeBgColor : 'transparent'),
						borderRight: '4px solid ' + (rootMenu.props.mode !== 'horizontal' && this.state.hover ? activeBgColor : 'transparent'),
						padding: '0px ' + padding * index + 'px'
					}, onClick: function onClick(e) {
						_this2.setState({ hover: false });
						rootMenu.setState({ activeLevelIndex: index - 1, activeMemberIndex: _this2.props.selfIndex, activeParentIndex: parentIndex });
						if (_onClick) {
							_onClick(index - 1, parentIndex, _this2.props.selfIndex);
						}
					}, onMouseOver: function onMouseOver(e) {
						_this2.setState({ hover: true });
					}, onMouseOut: function onMouseOut(e) {
						_this2.setState({ hover: false });
					} },
				_react2.default.createElement(
					_Left2.default,
					null,
					iconElement,
					_react2.default.createElement(_Label2.default, { content: label, fontFamily: fontFamily, fontSize: fontSize, color: textColor, height: height })
				)
			);
		}
	}]);

	return MenuItem;
}(_MixinComponent3.default);

MenuItem.propTypes = {
	label: _react.PropTypes.string,
	children: _react.PropTypes.node,
	icon: _react.PropTypes.node,
	onClick: _react.PropTypes.func
};
MenuItem.defaultProps = {
	label: 'MenuItem'
};
exports.default = MenuItem;