'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _MixinComponent2 = require('./MixinComponent');

var _MixinComponent3 = _interopRequireDefault(_MixinComponent2);

var _GridList = require('../Grid/GridList');

var _GridList2 = _interopRequireDefault(_GridList);

var _Label = require('../Label');

var _Label2 = _interopRequireDefault(_Label);

var _Popover = require('../Popover');

var _Popover2 = _interopRequireDefault(_Popover);

var _Left = require('../Left');

var _Left2 = _interopRequireDefault(_Left);

var _VerticalMiddle = require('../VerticalMiddle');

var _VerticalMiddle2 = _interopRequireDefault(_VerticalMiddle);

var _SvgIcon = require('../SvgIcon');

var _SvgIcon2 = _interopRequireDefault(_SvgIcon);

var _colorManipulator = require('../../utils/colorManipulator');

var _cloneElements = require('./cloneElements');

var _cloneElements2 = _interopRequireDefault(_cloneElements);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MenuItemGroup = function (_MixinComponent) {
	_inherits(MenuItemGroup, _MixinComponent);

	function MenuItemGroup(props) {
		_classCallCheck(this, MenuItemGroup);

		var _this = _possibleConstructorReturn(this, (MenuItemGroup.__proto__ || Object.getPrototypeOf(MenuItemGroup)).call(this, props));

		_this.type = 'MenuItemGroup';
		return _this;
	}

	_createClass(MenuItemGroup, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    label = _props.label,
			    children = _props.children,
			    icon = _props.icon;

			var menuProps = this.getMenuProps();
			// const rootMenu = menuProps.component;

			var height = menuProps.itemHeight;
			var activeBgColor = menuProps.itemActiveBgColor;
			var textColor = (0, _colorManipulator.darken)(menuProps.itemColor, 0.3);
			var fontFamily = menuProps.itemFontFamily;
			var fontSize = menuProps.itemFontSize;
			var padding = menuProps.itemPadding;

			var bgColor = menuProps.subBgColor;

			var rootMode = menuProps.mode;

			var index = menuProps.index;

			var _children = (0, _cloneElements2.default)(children);

			var PCPopoverStyle = {
				backgroundColor: bgColor,
				border: 'none',
				left: 0,
				top: 0,
				width: 'parent',
				minWidth: 150,
				borderRadius: 0,
				padding: 0,
				boxShadow: 'none',
				display: 'inline-block'
			};

			var iconSize = fontSize + 4;
			var marginSize = (height - iconSize) / 2;
			var iconStyle = {
				margin: marginSize + ' 5 ' + marginSize + ' 0'
			};

			var iconElement = icon !== undefined ? _react2.default.createElement(
				_VerticalMiddle2.default,
				{ height: height },
				_react2.default.cloneElement(icon, { color: textColor, width: iconSize, height: iconSize, style: iconStyle })
			) : '';

			var labelElement = _react2.default.createElement(_Label2.default, { content: label, fontFamily: fontFamily, fontSize: fontSize, color: textColor, height: height });
			var childRootElement = rootMode === 'vertical' || index > 1 ? _react2.default.createElement(
				'div',
				{ style: {
						margin: '0px ' + -padding * index + 'px',
						// padding: `0px ${padding}px`,
						backgroundColor: bgColor
					} },
				_children
			) : _react2.default.createElement(
				_Popover2.default,
				{ open: true, isUseSlideAnimation: true, maxHeight: 250, outClickClose: false, style: PCPopoverStyle, onRequestClose: function onRequestClose(e) {
						return _this2.setState({ activeIndex: -1, open: false });
					} },
				_react2.default.createElement(
					'div',
					{ style: { margin: '0px ' + -padding + 'px', backgroundColor: bgColor } },
					_children
				)
			);
			return _react2.default.createElement(
				'div',
				{ style: {
						// backgroundColor: this.state.hover ? activeBgColor : 'transparent',
						padding: '0px ' + padding * index + 'px'
					} },
				_react2.default.createElement(
					_Left2.default,
					null,
					iconElement,
					labelElement
				),
				childRootElement
			);
		}
	}]);

	return MenuItemGroup;
}(_MixinComponent3.default);

MenuItemGroup.propTypes = {
	label: _react.PropTypes.string,
	icon: _react.PropTypes.node,
	children: _react.PropTypes.node
};
MenuItemGroup.defaultProps = {
	label: 'MenuItemGroup'
};
exports.default = MenuItemGroup;