'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _colors = require('../../styles/colors.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MixinComponent = function (_Component) {
	_inherits(MixinComponent, _Component);

	function MixinComponent() {
		_classCallCheck(this, MixinComponent);

		return _possibleConstructorReturn(this, (MixinComponent.__proto__ || Object.getPrototypeOf(MixinComponent)).apply(this, arguments));
	}

	_createClass(MixinComponent, [{
		key: 'getChildContext',
		value: function getChildContext() {
			return {
				component: this
			};
		}
	}, {
		key: 'parent',
		value: function parent() {
			return this.context.component;
		}
	}, {
		key: 'indexPath',
		value: function indexPath() {
			var path = [this.props.index];
			var parent = this.parent();

			while (parent.type !== 'Menu') {
				if (parent.props.index) {
					path.unshift(parent.props.index);
				}

				parent = parent.parent();
			}

			return path;
		}
	}, {
		key: 'root',
		value: function root() {
			var index = 1;
			var parent = this.parent();

			while (parent.type !== 'Menu') {
				parent = parent.parent();
				index++;
			}

			return { component: parent, index: index };
		}
	}, {
		key: 'getMenuProps',
		value: function getMenuProps() {
			var root = this.root();
			var result = {
				component: root.component,
				index: root.index
			};
			result.itemHeight = result.component.props.itemHeight;
			result.itemActiveBgColor = result.component.props.itemActiveBgColor;
			result.itemColor = result.component.props.itemColor;
			result.itemFontFamily = result.component.props.itemFontFamily;
			result.itemFontSize = result.component.props.itemFontSize;
			result.itemPadding = result.component.props.itemPadding;
			result.subBgColor = result.component.props.subBgColor;
			result.mode = result.component.props.mode;

			var theme = result.component.props.theme;

			if (theme === 'dark') {
				result.subBgColor = _colors.GREY900;
				result.itemActiveBgColor = _colors.BLUE600;
				result.itemColor = _colors.GREY300;
			} else if (theme === 'light') {
				result.subBgColor = _colors.GREY300;
				result.itemActiveBgColor = _colors.BLUE100;
				result.itemColor = _colors.GREY800;
			}

			return result;
		}
	}]);

	return MixinComponent;
}(_react.Component);

MixinComponent.contextTypes = {
	component: _react.PropTypes.any
};
MixinComponent.childContextTypes = {
	component: _react.PropTypes.any
};
exports.default = MixinComponent;