'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _MixinComponent2 = require('./MixinComponent');

var _MixinComponent3 = _interopRequireDefault(_MixinComponent2);

var _GridList = require('../Grid/GridList');

var _GridList2 = _interopRequireDefault(_GridList);

var _Label = require('../Label');

var _Label2 = _interopRequireDefault(_Label);

var _Popover = require('../Popover');

var _Popover2 = _interopRequireDefault(_Popover);

var _Left = require('../Left');

var _Left2 = _interopRequireDefault(_Left);

var _VerticalMiddle = require('../VerticalMiddle');

var _VerticalMiddle2 = _interopRequireDefault(_VerticalMiddle);

var _SvgIcon = require('../SvgIcon');

var _SvgIcon2 = _interopRequireDefault(_SvgIcon);

var _Hardware = require('../../svgIcons/google/Hardware');

var _cloneElements = require('./cloneElements');

var _cloneElements2 = _interopRequireDefault(_cloneElements);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SubMenu = function (_MixinComponent) {
	_inherits(SubMenu, _MixinComponent);

	function SubMenu(props) {
		_classCallCheck(this, SubMenu);

		var _this = _possibleConstructorReturn(this, (SubMenu.__proto__ || Object.getPrototypeOf(SubMenu)).call(this, props));

		_this.state = {
			hover: false,
			open: props.open
		};

		_this.type = 'SubMenu';
		return _this;
	}

	_createClass(SubMenu, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    label = _props.label,
			    children = _props.children,
			    _onClick = _props.onClick,
			    icon = _props.icon;

			var menuProps = this.getMenuProps();
			var rootMenu = menuProps.component;

			var height = menuProps.itemHeight;
			var activeBgColor = menuProps.itemActiveBgColor;
			var textColor = menuProps.itemColor;
			var fontFamily = menuProps.itemFontFamily;
			var fontSize = menuProps.itemFontSize;
			var padding = menuProps.itemPadding;

			var bgColor = menuProps.subBgColor;

			var rootMode = menuProps.mode;

			var index = menuProps.index;

			var PCPopoverStyle = {
				backgroundColor: bgColor,
				border: 'none',
				left: 0,
				top: 0,
				width: 'parent',
				minWidth: 150,
				borderRadius: 0,
				padding: 0,
				boxShadow: 'none',
				display: 'inline-block'
			};

			var iconSize = fontSize + 4,
			    arrowSize = 20;
			var arrowStyle = {
				margin: '0 0 0 10'
			};

			var iconStyle = {
				margin: (height - iconSize) / 2,
				marginRight: 5,
				marginLeft: 0
			};

			var _children = (0, _cloneElements2.default)(children);

			var iconElement = icon !== undefined ? _react2.default.createElement(
				_VerticalMiddle2.default,
				{ height: height },
				_react2.default.cloneElement(icon, { color: textColor, width: iconSize, height: iconSize, style: iconStyle })
			) : '';

			var labelElement = _react2.default.createElement(_Label2.default, { content: label, fontFamily: fontFamily, fontSize: fontSize, color: textColor, height: height });
			var arrowElement = _react2.default.createElement(
				_VerticalMiddle2.default,
				{ height: height },
				_react2.default.createElement(
					_SvgIcon2.default,
					{ color: textColor, width: arrowSize, height: arrowSize, style: arrowStyle },
					_react2.default.createElement('path', { d: this.state.open ? _Hardware.gKeyboardArrowDown : _Hardware.gKeyboardArrowRight })
				)
			);
			var childRootElement = rootMode === 'vertical' || index > 1 ? _react2.default.createElement(
				'div',
				{ style: {
						display: this.state.open ? 'block' : 'none',
						margin: '0px ' + -padding * index + 'px',
						// padding: `0px ${padding}px`,
						backgroundColor: bgColor
					} },
				_children
			) : _react2.default.createElement(
				_Popover2.default,
				{ open: this.state.open, isUseSlideAnimation: true, maxHeight: 250, outClickClose: false, style: PCPopoverStyle, onRequestClose: function onRequestClose(e) {
						return _this2.setState({ activeIndex: -1, open: false });
					} },
				_react2.default.createElement(
					'div',
					{ style: { margin: '0px ' + -padding + 'px', backgroundColor: bgColor } },
					_children
				)
			);
			return _react2.default.createElement(
				'div',
				{ style: {
						// boxSizing: 'border-box',
						padding: '0px ' + padding * index + 'px'
					}, onMouseOver: function onMouseOver(e) {
						_this2.setState({ hover: true });
						if (rootMode !== 'vertical') {
							_this2.setState({ open: true });
						};
					}, onMouseOut: function onMouseOut(e) {
						_this2.setState({ hover: false });
						if (rootMode !== 'vertical') {
							_this2.setState({ open: false });
						}
					} },
				_react2.default.createElement(
					'div',
					{ onClick: function onClick(e) {
							_this2.setState({ open: !_this2.state.open });
							if (_onClick) {
								_onClick();
							}
						} },
					_react2.default.createElement(
						_Left2.default,
						null,
						iconElement,
						labelElement,
						arrowElement
					)
				),
				childRootElement
			);
		}
	}]);

	return SubMenu;
}(_MixinComponent3.default);

SubMenu.propTypes = {
	label: _react.PropTypes.string,
	open: _react.PropTypes.bool,
	icon: _react.PropTypes.node,
	children: _react.PropTypes.node,
	bgColor: _react.PropTypes.string,
	onClick: _react.PropTypes.func
};
SubMenu.defaultProps = {
	label: 'SubMenu',
	open: false
};
exports.default = SubMenu;