'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Overlay = require('./Overlay');

var _Overlay2 = _interopRequireDefault(_Overlay);

var _Paper = require('./Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _constants = require('../styles/constants');

var _colors = require('../styles/colors');

var _IconButton = require('./Button/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _SvgIcon = require('./SvgIcon');

var _SvgIcon2 = _interopRequireDefault(_SvgIcon);

var _Content = require('../svgIcons/google/Content');

var _RaisedButton = require('./Button/RaisedButton');

var _RaisedButton2 = _interopRequireDefault(_RaisedButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

require('../csses/clearfix.css');

function getStyles(props, state) {
	var padding = 20;
	return {
		modal: {
			position: 'fixed',
			top: 0,
			left: 0,
			right: 0,
			display: state.open ? 'block' : 'none',
			width: '75%',
			maxWidth: _constants.MODAL_MAX_WIDTH,
			margin: '80px auto',
			zIndex: _constants.MODAL_ZINDEX
		},

		overlay: {
			zIndex: _constants.OVERLAY_ZINDEX
		},

		modalHeader: {
			padding: padding,
			borderBottom: '1px solid ' + props.splitColor,
			position: 'relative',
			color: props.titleColor,
			fontFamily: props.fontFamily,
			fontSize: props.titleFontSize
		},

		close: {
			position: 'absolute',
			top: 0,
			right: 0,
			padding: 16
		},

		modalBody: {
			padding: padding
		},

		modalFooter: {
			padding: '8px ' + padding + 'px',
			borderTop: '1px solid ' + props.splitColor
		}
	};
}

var Modal = function (_Component) {
	_inherits(Modal, _Component);

	function Modal(props) {
		_classCallCheck(this, Modal);

		var _this = _possibleConstructorReturn(this, (Modal.__proto__ || Object.getPrototypeOf(Modal)).call(this, props));

		_this.state = {
			open: props.open
		};
		return _this;
	}

	_createClass(Modal, [{
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(newProps) {
			if (newProps !== undefined && newProps.open !== this.state.open) {
				this.setState({ open: newProps.open });
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    overlayStyle = _props.overlayStyle,
			    style = _props.style,
			    title = _props.title,
			    actions = _props.actions,
			    children = _props.children,
			    useActions = _props.useActions,
			    onOkClick = _props.onOkClick,
			    onCancelClick = _props.onCancelClick;


			if (_react2.default.Children.count(actions) <= 0 && useActions) {
				actions = [_react2.default.createElement(_RaisedButton2.default, { label: '\u53D6\u6D88', style: { marginRight: 10, padding: '0px 20px' }, bgColor: _colors.PINK300, onClick: function onClick(e) {
						_this2.setState({ open: false });
						if (onCancelClick) {
							onCancelClick(e, false);
						}
					} }), _react2.default.createElement(_RaisedButton2.default, { label: '\u786E\u5B9A', style: { padding: '0px 20px' }, bgColor: _colors.CYAN500, onClick: function onClick(e) {
						if (onOkClick) {
							onOkClick(e);
						}
					} })];
			}

			var styles = getStyles(this.props, this.state);

			var footer = actions && useActions ? _react2.default.createElement(
				'div',
				{ style: styles.modalFooter },
				_react2.default.createElement(
					'div',
					{ className: 'clearfix' },
					_react2.default.createElement(
						'div',
						{ style: { float: 'right' } },
						_react2.default.Children.toArray(actions)
					)
				)
			) : '';

			var header = title && title.length > 0 ? _react2.default.createElement(
				'div',
				{ style: styles.modalHeader },
				title,
				_react2.default.createElement(
					'div',
					{ style: styles.close, onClick: function onClick(e) {
							_this2.setState({ open: false });
							if (onCancelClick) {
								onCancelClick(e, false);
							}
						} },
					_react2.default.createElement(_IconButton2.default, { color: _colors.GREY300, hoverColor: _colors.PINK300, padding: 0, icon: _react2.default.createElement(
							_SvgIcon2.default,
							null,
							_react2.default.createElement('path', { d: _Content.gClear })
						) })
				)
			) : '';
			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					'div',
					{ style: styles.modal },
					_react2.default.createElement(
						_Paper2.default,
						{ style: style },
						header,
						_react2.default.createElement(
							'div',
							{ style: styles.modalBody },
							children
						),
						footer
					)
				),
				_react2.default.createElement(_Overlay2.default, { show: this.state.open, style: Object.assign({}, styles.overlay, overlayStyle) })
			);
		}
	}]);

	return Modal;
}(_react.Component);

Modal.propTypes = {
	children: _react.PropTypes.node,
	open: _react.PropTypes.bool,
	overlayStyle: _react.PropTypes.object,
	style: _react.PropTypes.object,
	title: _react.PropTypes.string,
	titleColor: _react.PropTypes.string,
	splitColor: _react.PropTypes.string,
	fontFamily: _react.PropTypes.string,
	titleFontSize: _react.PropTypes.number,
	useActions: _react.PropTypes.bool,
	actions: _react.PropTypes.node,
	onOkClick: _react.PropTypes.func,
	onCancelClick: _react.PropTypes.func
};
Modal.defaultProps = {
	open: false,
	overlayStyle: {},
	style: {},
	useActions: true,
	splitColor: _colors.GREY300,
	titleColor: _colors.GREY300,
	fontFamily: _constants.FONT_FAMILY_DEFAULT,
	titleFontSize: _constants.FONT_SIZE_DEFAULT
};
exports.default = Modal;