'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _constants = require('../styles/constants');

var _Paper = require('./Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _colors = require('../styles/colors');

var _dom = require('../utils/dom');

var _dom2 = _interopRequireDefault(_dom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getStyles(props, state) {
	var zDepth = props.zDepth;


	var Temp = { position: 'relative',
		top: 0,
		left: 0,
		width: '100%' };

	if (props.isopacity) {
		Temp.opacity = state.open ? 1 : 0;
	} else {
		Temp.display = state.open ? 'block' : 'none';
	}

	return {
		root: Temp,
		self: {
			// backgroundColor: '#f00',
			border: '1px solid ' + _colors.GREY300,
			position: 'absolute',
			top: 0,
			left: 0,
			padding: _constants.GUTTER,
			width: '100%',
			zIndex: zDepth
		}
	};
}

var Popover = function (_Component) {
	_inherits(Popover, _Component);

	function Popover(props) {
		_classCallCheck(this, Popover);

		var _this = _possibleConstructorReturn(this, (Popover.__proto__ || Object.getPrototypeOf(Popover)).call(this, props));

		_this.handleRequestClose = function (e) {
			// console.log( Dom.isDescendant(this.element, e.target), document.documentElement.contains(e.target));
			if (!(e.target == _this.element || _dom2.default.isDescendant(_this.element, e.target))) {
				if (_this.state.open) {
					_this.setState({ open: false });
				}
				if (_this.props.onRequestClose) {
					_this.props.onRequestClose(e);
				}
				window.removeEventListener('mouseup', _this.handleRequestClose, false);
			}
		};

		_this.state = {
			open: props.open
		};
		return _this;
	}

	_createClass(Popover, [{
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(newProps) {
			if (newProps.open !== this.state.open) {
				this.setState({ open: newProps.open });
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			if (this.state.open) {
				setTimeout(function () {
					window.addEventListener('mouseup', _this2.handleRequestClose, false);
				}, 0);
			}

			var _props = this.props,
			    children = _props.children,
			    style = _props.style;

			var styles = getStyles(this.props, this.state);
			return _react2.default.createElement(
				'div',
				{ style: styles.root },
				_react2.default.createElement(
					_Paper2.default,
					{ style: Object.assign({}, styles.self, style), ref: function ref(_ref) {
							return _this2.element = _reactDom2.default.findDOMNode(_ref);
						} },
					children
				)
			);
		}
	}]);

	return Popover;
}(_react.Component);

Popover.propTypes = {
	children: _react.PropTypes.node,
	onRequestClose: _react.PropTypes.func,
	open: _react.PropTypes.bool,
	isopacity: _react.PropTypes.bool,
	style: _react.PropTypes.object,
	zDepth: _react.PropTypes.number
};
Popover.defaultProps = {
	isopacity: false,
	open: false,
	zDepth: 10
};
exports.default = Popover;