'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SvgIcon = require('./SvgIcon');

var _SvgIcon2 = _interopRequireDefault(_SvgIcon);

var _Hardware = require('../svgIcons/google/Hardware');

var _colors = require('../styles/colors');

var _Paper = require('./Paper');

var _Paper2 = _interopRequireDefault(_Paper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// import { HardwareKeyboardArrowDown, HardwareKeyboardArrowRight} from 'material-ui/svg-icons';


var PopupPanel = function (_Component) {
  _inherits(PopupPanel, _Component);

  function PopupPanel(props) {
    _classCallCheck(this, PopupPanel);

    var _this = _possibleConstructorReturn(this, (PopupPanel.__proto__ || Object.getPrototypeOf(PopupPanel)).call(this, props));

    _this.state = {
      open: props.open,
      scaleY: props.open ? 1 : 0,
      bodyHeight: props.bodyHeight
    };
    return _this;
  }

  _createClass(PopupPanel, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(newProps) {
      if (newProps.open !== undefined) {
        this.setState({ open: newProps.open, scaleY: newProps.open ? 1 : 0 });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var style = {
        position: 'relative',
        // height: this.state.open ? 'auto' : this.props.headerHeight + 2 * this.props.padding,
        // boxShadow: '1px 1px 1px 1px rgba(0, 0, 0, 0.05)',
        zIndex: this.props.zDepth
      };

      var headerStyle = {
        boxSizing: 'border-box',
        border: '1px solid ' + this.props.borderColor,
        height: this.props.headerHeight + 2 * this.props.padding,
        backgroundColor: this.props.headerBgColor,
        borderTopLeftRadius: this.props.radius,
        borderTopRightRadius: this.props.radius,
        borderBottomLeftRadius: this.state.open ? 0 : this.props.radius,
        borderBottomRightRadius: this.state.open ? 0 : this.props.radius,
        fontWeight: 'bold',
        fontSize: 16,
        padding: this.props.padding
      };
      var bodyStyle = {
        boxSizing: 'border-box',
        borderLeft: '1px solid ' + this.props.borderColor,
        borderRight: '1px solid ' + this.props.borderColor,
        borderBottom: this.state.open ? '1px solid ' + this.props.borderColor : 'none',
        broderTop: 'none',

        backgroundColor: this.props.bodyBgColor,
        borderBottomLeftRadius: this.props.radius,
        borderBottomRightRadius: this.props.radius,
        overflow: this.props.overflow,
        height: this.props.bodyHeight + 2 * this.props.padding,
        // display: this.state.scaleY > 0 ? 'block' : 'none',
        // transform: `scaleY(${this.state.scaleY})`,
        display: this.state.open ? 'block' : 'none',
        padding: this.state.open ? this.props.padding : 0,
        // opacity: this.state.open ? 1 : 0,

        // width: this.state.open ? '100%' : 0,
        // transform: this.state.open ? 'scaleY(1)' : 'scaleY(0)',
        transformOrigin: '0 0'
        // transition: 'all 0.3s ease-in-out'
      };

      var arrowStyle = {
        position: 'absolute',
        right: 0,
        top: this.props.padding,
        zIndex: this.props.zDepth + 1
      };
      return _react2.default.createElement(
        _Paper2.default,
        { style: Object.assign(style, this.props.style) },
        _react2.default.createElement(
          'div',
          { style: Object.assign(headerStyle, this.props.headerStyle), onClick: function onClick(e) {
              // this.setState({open: !this.state.open});

              var open = _this2.state.open;
              _this2.setState({ open: !open });
              // let scaleY = this.state.scaleY;

              // console.log('cx***: ', this.state);
              // // let step = Math.floor(this.props.bodyHeight / 10);
              // let step = 0.01;
              // let timer = setInterval(() => {
              //   console.log(open, scaleY);
              //   if(open) {
              //     if(scaleY < step) {
              //       clearInterval(timer);
              //     } else {
              //       scaleY -= step;
              //       this.setState({scaleY: scaleY});
              //     }
              //   } else {
              //     if(scaleY > (1 - step)) {
              //       clearInterval(timer);
              //     } else {
              //       scaleY += step;
              //       // console.log('dfefe');
              //       this.setState({scaleY: scaleY});
              //     }

              //   }
              // }, 0);

              if (_this2.props.onClick) {
                _this2.props.onClick(e);
              }

              // e.preventDefault();
              // e.stopPropagation();
            } },
          this.props.label,
          this.state.open ? _react2.default.createElement(
            _SvgIcon2.default,
            { style: arrowStyle, color: '#000' },
            _react2.default.createElement('path', { d: _Hardware.gKeyboardArrowDown })
          ) : _react2.default.createElement(
            _SvgIcon2.default,
            { style: arrowStyle, color: '#000' },
            _react2.default.createElement('path', { d: _Hardware.gKeyboardArrowRight })
          )
        ),
        _react2.default.createElement(
          'div',
          { style: Object.assign(bodyStyle, this.props.bodyStyle) },
          this.props.children
        )
      );
    }
  }]);

  return PopupPanel;
}(_react.Component);

exports.default = PopupPanel;


PopupPanel.defaultProps = {
  open: false,
  overflow: 'auto',
  borderColor: _colors.GREY300,
  headerHeight: 26,
  headerBgColor: _colors.GREY200,
  bodyHeight: 100,
  bodyBgColor: '#fff',
  radius: 2,
  padding: 5,
  style: {},
  headerStyle: {},
  bodyStyle: {},
  zDepth: 1
};

PopupPanel.propTypes = {
  open: _react.PropTypes.bool,
  overflow: _react.PropTypes.string,
  label: _react.PropTypes.string.isRequired,
  borderColor: _react.PropTypes.string,
  headerHeight: _react.PropTypes.number,
  headerBgColor: _react.PropTypes.string,
  bodyHeight: _react.PropTypes.number,
  bodyBgColor: _react.PropTypes.string,
  radius: _react.PropTypes.number,
  padding: _react.PropTypes.number,
  style: _react.PropTypes.object,
  headerStyle: _react.PropTypes.object,
  bodyStyle: _react.PropTypes.object,
  zDepth: _react.PropTypes.number
};