'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _colors = require('../styles/colors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Select = function (_Component) {
  _inherits(Select, _Component);

  function Select(props) {
    _classCallCheck(this, Select);

    var _this = _possibleConstructorReturn(this, (Select.__proto__ || Object.getPrototypeOf(Select)).call(this, props));

    _this.state = {
      activeIndex: props.activeIndex
    };
    return _this;
  }

  _createClass(Select, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.activeIndex !== undefined) {
        this.setState({ activeIndex: nextProps.activeIndex });
      }
    }
  }, {
    key: 'renderItems',
    value: function renderItems() {
      return this.props.items.map(function (item, index) {
        return _react2.default.createElement(
          'option',
          { key: index, value: index },
          item
        );
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var items = this.props.items;

      var defaultStyle = {
        width: '100%',
        height: 30,
        display: 'block',
        verticalAlign: 'middle',
        padding: '6px 12px',
        border: '1px solid ' + _colors.GREY300,
        backgroundColor: '#fff',
        outline: 'none',
        // WebkitAppearance: 'none',
        // MozAppearance: 'none',
        // appearance: 'none',
        borderRadius: 4
      };
      return _react2.default.createElement(
        'select',
        { style: Object.assign({}, defaultStyle, this.props.style), value: this.state.activeIndex, onChange: function onChange(e) {

            var index = parseInt(e.target.value);
            var val = items[index];
            _this2.setState({ activeIndex: index });
            if (_this2.props.onChange) {
              _this2.props.onChange(e, val, index);
            }
          } },
        this.renderItems()
      );
    }
  }]);

  return Select;
}(_react.Component);

Select.propTypes = {
  items: _react.PropTypes.array,
  activeIndex: _react.PropTypes.number,
  style: _react.PropTypes.object
};
Select.defaultProps = {
  activeIndex: 0,
  style: {}
};
exports.default = Select;