'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SimpleItem = function (_Component) {
  _inherits(SimpleItem, _Component);

  function SimpleItem(props) {
    _classCallCheck(this, SimpleItem);

    var _this = _possibleConstructorReturn(this, (SimpleItem.__proto__ || Object.getPrototypeOf(SimpleItem)).call(this, props));

    _this.state = {
      active: props.active
    };
    return _this;
  }

  _createClass(SimpleItem, [{
    key: 'onHandleClick',
    value: function onHandleClick(event) {
      this.setState({ active: true });
      if (this.props.onClick) {
        var other = this.props.other ? this.props.other : null;
        this.props.onClick(event, this.props.title);
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(newProps) {
      if (newProps.active !== undefined) {
        this.state.active = newProps.active;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var border = 'none';
      if (this.state.active && this.props.activeColor) {
        border = '1px solid ' + this.props.activeColor;
      } else if (this.props.defaultBorderColor) {
        border = '1px solid ' + this.props.defaultBorderColor;
      }

      return _react2.default.createElement(
        'div',
        {
          onClick: this.onHandleClick.bind(this),
          style: {
            padding: this.state.active || this.props.defaultBorderColor ? 4 : 5,
            textAlign: 'center',
            border: border
          } },
        this.props.children,
        this.props.title ? _react2.default.createElement(
          'div',
          { style: { fontSize: 12 } },
          this.props.title
        ) : ''
      );
    }
  }]);

  return SimpleItem;
}(_react.Component);

exports.default = SimpleItem;


SimpleItem.defaultProps = {
  active: false,
  activeColor: '#0f0'
};

SimpleItem.propTypes = {
  active: _react.PropTypes.bool,
  defaultBorderColor: _react.PropTypes.string,
  activeColor: _react.PropTypes.string,
  title: _react.PropTypes.string,
  onClick: _react.PropTypes.func
};