'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _colors = require('../styles/colors');

var _SetToRange = require('../utils/SetToRange');

var _SetToRange2 = _interopRequireDefault(_SetToRange);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getStyles(props) {
	return {
		root: {
			// backgroundColor: '#0f0',
			// cursor: 'pointer',
			position: 'relative',
			height: props.dotRadius * 2
		},
		bar: {
			// cursor: 'pointer',
			backgroundColor: props.barBgColor,
			// width: '100%',
			height: props.barHeight,
			position: 'relative',
			left: 0,
			top: props.dotRadius - props.barHeight / 2
		},
		track: {
			// backgroundColor: '#f00',
			height: props.barHeight,
			marginRight: props.dotRadius * 2,
			position: 'relative',
			left: 0,
			top: 0
		},
		trackBar: {
			backgroundColor: props.dotBgColor,
			height: props.barHeight,
			position: 'absolute',
			top: 0,
			left: 0
		},
		dot: {
			backgroundColor: props.dotBgColor,
			width: props.dotRadius * 2,
			height: props.dotRadius * 2,
			borderRadius: props.dotRadius,
			position: 'absolute',
			top: -props.dotRadius + props.barHeight / 2,
			left: 0
		}
	};
}

var Slider = function (_Component) {
	_inherits(Slider, _Component);

	function Slider(props) {
		_classCallCheck(this, Slider);

		var _this = _possibleConstructorReturn(this, (Slider.__proto__ || Object.getPrototypeOf(Slider)).call(this, props));

		_this.dragMouseHandler = function (e) {
			if (_this.state.isMoved) {
				_this.setPercentAndValue(e);
			}
		};

		_this.dragMouseEndHandler = function (e) {
			if (document) {
				document.removeEventListener('mousemove', _this.dragMouseHandler, false);
				document.removeEventListener('mouseup', _this.dragMouseEndHandler, false);
				document.removeEventListener('touchmove', _this.dragMouseHandler, false);
				document.removeEventListener('touchend', _this.dragMouseEndHandler, false);
			}

			_this.setState({ isMoved: false });

			if (_this.props.onDragEnd) {
				_this.props.onDragEnd(e, _this.state.value);
			}
		};

		_this.state = {
			value: 0,
			percent: 0,
			isMoved: false
		};
		return _this;
	}

	_createClass(Slider, [{
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(newProps) {
			if (newProps.value !== undefined) {
				var value = (0, _SetToRange2.default)(newProps.value, this.props.min, this.props.max);
				var percent = this.valueToPercent(value);

				this.setState({
					value: value,
					percent: percent
				});
			}
		}
	}, {
		key: 'componentWillMount',
		value: function componentWillMount() {
			var value = this.props.value;
			if (value === undefined) {
				value = this.props.defaultValue !== undefined ? this.props.defaultValue : this.props.min;
			}
			var percent = (value - this.props.min) / (this.props.max - this.props.min);
			if (isNaN(percent)) {
				percent = 0;
			}

			this.stepPercent = this.props.step / (this.props.max - this.props.min);

			this.setState({
				percent: percent,
				value: value
			});
		}
	}, {
		key: 'componentDidMount',
		value: function componentDidMount() {
			console.log('render end');
		}
	}, {
		key: 'handleMouseDown',
		value: function handleMouseDown(e) {

			this.setState({ isMoved: true });
			this.setPercentAndValue(e);
			if (document) {
				document.addEventListener('mousemove', this.dragMouseHandler, false);
				document.addEventListener('mouseup', this.dragMouseEndHandler, false);
				document.addEventListener('touchmove', this.dragMouseHandler, false);
				document.addEventListener('touchend', this.dragMouseEndHandler, false);
				e.preventDefault();
			}

			if (this.props.onDragStart) {
				this.props.onDragStart(e, this.state.value);
			}
		}
	}, {
		key: 'setPercentAndValue',
		value: function setPercentAndValue(event) {
			var positionX = event.clientX;
			if (event.type == 'touchstart' || event.type == 'touchmove') {
				positionX = event.touches[0].clientX;;
			}

			var width = this.sliderBar.clientWidth;

			var left = this.getBarLeft();
			var changeLeft = positionX - left;

			var changeLeftPercent = changeLeft / width;

			var changePercent = changeLeftPercent - this.state.percent;
			var count = parseInt(changePercent / this.stepPercent);

			var value = (0, _SetToRange2.default)(this.state.value + count * this.props.step, this.props.min, this.props.max);

			changeLeftPercent = this.valueToPercent(value);

			if (this.props.onChange && value !== this.state.value) {
				this.props.onChange(event, value);
			}

			this.setState({
				percent: changeLeftPercent,
				value: value
			});
		}
	}, {
		key: 'percentToValue',
		value: function percentToValue(percent) {
			return percent * (this.props.max - this.props.min) + this.props.min;
		}
	}, {
		key: 'valueToPercent',
		value: function valueToPercent(value) {
			return (value - this.props.min) / (this.props.max - this.props.min);
		}
	}, {
		key: 'getBarLeft',
		value: function getBarLeft() {
			return this.sliderBar.getBoundingClientRect().left;
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var styles = getStyles(this.props);
			var dotStyle = styles.dot;

			var stringPercent = this.state.percent * 100 + '%';

			dotStyle.left = stringPercent;

			var trackBarStyle = styles.trackBar;
			trackBarStyle.width = stringPercent;

			return _react2.default.createElement(
				'div',
				{ style: Object.assign({}, styles.root, this.props.style),
					onMouseDown: this.handleMouseDown.bind(this),
					onTouchStart: this.handleMouseDown.bind(this) },
				_react2.default.createElement(
					'div',
					{ style: Object.assign({}, styles.bar, this.props.barStyle) },
					_react2.default.createElement(
						'div',
						{ style: styles.track,
							ref: function ref(_ref2) {
								return _this2.sliderBar = _ref2;
							} },
						_react2.default.createElement('div', { style: trackBarStyle }),
						_react2.default.createElement('div', {
							style: Object.assign({}, dotStyle, this.props.dotStyle),
							ref: function ref(_ref) {
								return _this2.sliderDot = _ref;
							} })
					)
				)
			);
		}
	}]);

	return Slider;
}(_react.Component);

Slider.propTypes = {
	barBgColor: _react.PropTypes.string,
	barHeight: _react.PropTypes.number,
	dotBgColor: _react.PropTypes.string,
	dotRadius: _react.PropTypes.number,
	defaultValue: _react.PropTypes.number,
	onChange: _react.PropTypes.func,
	onDragStart: _react.PropTypes.func,
	onDragEnd: _react.PropTypes.func,
	max: _react.PropTypes.number,
	min: _react.PropTypes.number,
	step: _react.PropTypes.number
};
Slider.defaultProps = {
	barBgColor: _colors.GREY300,
	barHeight: 3,
	dotBgColor: _colors.CYAN500,
	dotRadius: 6,
	defaultValue: 0.5,
	max: 1,
	min: 0,
	step: 0.01
};
exports.default = Slider;