'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _constants = require('../styles/constants');

var _Is = require('../utils/Is');

var _Is2 = _interopRequireDefault(_Is);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

require('../csses/clearfix.css');

function getStyles(props) {
	return {
		root: {
			marginLeft: -props.gutter / 2,
			marginRight: -props.gutter / 2
		},

		item: {
			float: 'left',
			boxSizing: 'border-box',
			paddingLeft: props.gutter / 2,
			paddingRight: props.gutter / 2
		}
	};
}

var SpecialGridList = function (_Component) {
	_inherits(SpecialGridList, _Component);

	function SpecialGridList(props) {
		_classCallCheck(this, SpecialGridList);

		var _this = _possibleConstructorReturn(this, (SpecialGridList.__proto__ || Object.getPrototypeOf(SpecialGridList)).call(this, props));

		_this.state = {
			activeId: props.activeId
		};
		return _this;
	}

	_createClass(SpecialGridList, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var styles = getStyles(this.props);

			var _props = this.props,
			    children = _props.children,
			    cols = _props.cols,
			    specialRatio = _props.specialRatio,
			    center = _props.center;


			if (!(0, _Is2.default)(children, 'Array')) {
				children = [children];
			}

			var eachWidth = 100 / (cols + specialRatio);

			var wrappedChildren = children.map(function (child, index) {
				var itemStyle = Object.assign({}, styles.item, {
					width: index === _this2.state.activeId ? eachWidth * (1 + specialRatio) + '%' : eachWidth + '%',
					// transition: 'width 0.2s',
					textAlign: center ? 'center' : 'left'
				});
				return _react2.default.createElement(
					'div',
					{ key: 'grid_' + index, style: Object.assign({}, itemStyle), onClick: function onClick(e) {
							if (_this2.state.activeId !== index) {
								_this2.setState({ activeId: index });
							}
						} },
					child
				);
			});

			return _react2.default.createElement(
				'div',
				{ style: Object.assign({}, styles.root, this.props.style), className: 'clearfix' },
				wrappedChildren
			);
		}
	}]);

	return SpecialGridList;
}(_react.Component);

SpecialGridList.propTypes = {
	children: _react.PropTypes.node,
	center: _react.PropTypes.bool,
	cols: _react.PropTypes.number,
	specialRatio: _react.PropTypes.number,
	activeId: _react.PropTypes.number,
	gutter: _react.PropTypes.number,
	style: _react.PropTypes.object
};
SpecialGridList.defaultProps = {
	cols: 2,
	specialRatio: 0.5,
	activeId: 0,
	center: false,
	gutter: _constants.GUTTER
};
exports.default = SpecialGridList;