'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _constants = require('../styles/constants');

var _Is = require('../utils/Is');

var _Is2 = _interopRequireDefault(_Is);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getStyles(props) {
	return {
		root: {
			marginBottom: -props.gutter
		},

		item: {
			paddingBottom: props.gutter
		}
	};
}

var VerticalSeparation = function (_Component) {
	_inherits(VerticalSeparation, _Component);

	function VerticalSeparation() {
		_classCallCheck(this, VerticalSeparation);

		return _possibleConstructorReturn(this, (VerticalSeparation.__proto__ || Object.getPrototypeOf(VerticalSeparation)).apply(this, arguments));
	}

	_createClass(VerticalSeparation, [{
		key: 'render',
		value: function render() {
			var styles = getStyles(this.props);

			var children = this.props.children;


			if (!(0, _Is2.default)(children, 'Array')) {
				children = [children];
			}

			var wrappedChildren = children.map(function (child, index) {
				return _react2.default.createElement(
					'div',
					{ key: 'vs_' + index, style: styles.item },
					child
				);
			});
			return _react2.default.createElement(
				'div',
				{ style: styles.root },
				wrappedChildren
			);
		}
	}]);

	return VerticalSeparation;
}(_react.Component);

VerticalSeparation.propTypes = {
	children: _react.PropTypes.node.isRequired,
	gutter: _react.PropTypes.number
};
VerticalSeparation.defaultProps = {
	gutter: _constants.GUTTER
};
exports.default = VerticalSeparation;