'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

/**
 * [getTextSize description]
 * @param  {[type]} text    [description]
 * @param  {[type]} options [description]
 * @return {[type]}         [description]
 */
exports.default = function (text, options) {
  options = options || {};
  options.font = options.font || 'Times';
  options.fontSize = options.fontSize || '16pt';
  options.fontWeight = options.fontWeight || 'normal';
  options.space = options.space || 0;

  if (!window.FUN_CANVAS_CONTEXT) {
    var _canvas = document.createElement('canvas');
    window.FUN_CANVAS_CONTEXT = _canvas.getContext('2d');
  }

  window.FUN_CANVAS_CONTEXT.font = options.fontSize + ' ' + options.font + ' ' + options.fontWeight;

  var width = 0;
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = text[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var each = _step.value;

      width += window.FUN_CANVAS_CONTEXT.measureText(each).width;
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  width += (text.length - 1) * options.space;

  return width;
};