'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

exports.default = function (image, width, height) {
	var mCanvas = document.createElement('canvas');
	mCanvas.width = width;
	mCanvas.height = height;

	var iWidth = image.width,
	    iHeight = image.height;

	var iRatio = iWidth / iHeight,
	    ratio = width / height,
	    ratioW = iWidth / width,
	    ratioH = iHeight / height;

	var mContext = mCanvas.getContext('2d');

	mContext.fillStyle = '#ffffff';
	mContext.fillRect(0, 0, width, height);

	if (iRatio > ratio) {
		mContext.drawImage(image, 0, 0, iWidth, iHeight, 0, 0, width, iHeight / ratioW);
	} else {
		mContext.drawImage(image, 0, 0, iWidth, iHeight, 0, 0, iWidth / ratioH, height);
	}

	return mCanvas.toDataURL();
};