'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Curve2 = require('./Curve');

var _Curve3 = _interopRequireDefault(_Curve2);

var _Point = require('../math/Point2');

var _Point2 = _interopRequireDefault(_Point);

var _utils = require('./utils');

var _LineCurve = require('./LineCurve');

var _LineCurve2 = _interopRequireDefault(_LineCurve);

var _bezierJs = require('bezier-js');

var _bezierJs2 = _interopRequireDefault(_bezierJs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CubicBezierCurve = function (_Curve) {
	_inherits(CubicBezierCurve, _Curve);

	function CubicBezierCurve(v0, v1, v2, v3) {
		_classCallCheck(this, CubicBezierCurve);

		var _this = _possibleConstructorReturn(this, (CubicBezierCurve.__proto__ || Object.getPrototypeOf(CubicBezierCurve)).call(this));

		_this.v0 = v0;
		_this.v1 = v1;
		_this.v2 = v2;
		_this.v3 = v3;
		_this.type = 'CubicBezierCurve';
		return _this;
	}

	_createClass(CubicBezierCurve, [{
		key: 'copy',
		value: function copy(cubic) {
			this.v0.copy(cubic.v0);
			this.v1.copy(cubic.v1);
			this.v2.copy(cubic.v2);
			this.v3.copy(cubic.v3);
			return this;
		}
	}, {
		key: 'clone',
		value: function clone() {
			return new CubicBezierCurve().copy(this);
		}
	}, {
		key: 'getPoint',
		value: function getPoint(t) {
			return new _Point2.default((0, _utils.CubicBezierPointFormula)(t, this.v0.x, this.v1.x, this.v2.x, this.v3.x), (0, _utils.CubicBezierPointFormula)(t, this.v0.y, this.v1.y, this.v2.y, this.v3.y));
		}
	}, {
		key: 'getTangent',
		value: function getTangent(t) {
			return new _Point2.default((0, _utils.CubicBezierTangentFormula)(t, this.v0.x, this.v1.x, this.v2.x, this.v3.x), (0, _utils.CubicBezierTangentFormula)(t, this.v0.y, this.v1.y, this.v2.y, this.v3.y));
		}
	}, {
		key: 'offset',
		value: function offset(distance) {
			// let tv0 = this.v0.clone(),
			// 	tv1 = this.v1.clone(),
			// 	tv2 = this.v2.clone(),
			// 	tv3 = this.v3.clone();
			// if(tv0.isApproximately(tv1)) {
			// 	tv1.x += 0.0001;
			// }
			// if(tv1.isApproximately(tv2)) {
			// 	tv2.x += 0.0001;
			// }

			// if(tv2.isApproximately(tv3)) {
			// 	tv2.x += 0.0001;
			// }

			// let l1 = new LineCurve(tv0, tv1);
			// let l2 = new LineCurve(tv1.clone(), tv2);
			// let l3 = new LineCurve(tv2.clone(), tv3);
			// // console.log('oo: ', l1, l2, l3);
			// l1.offset(distance);
			// l2.offset(distance);
			// l3.offset(distance);
			// // console.log('rr: ', l1, l2, l3);
			// this.v0.copy(l1.v0);
			// this.v3.copy(l3.v1);
			// console.log(l1);
			// let inter1 = l1.intersection(l2);
			// console.log('inter1: ', inter1);
			// if(!inter1) {
			// 	inter1 = l1.v1;
			// }
			// this.v1.copy(inter1);

			// let inter2 = l2.intersection(l3);
			// console.log('inter2: ', inter2);
			// if(!inter2) {
			// 	inter2 = l2.v1;
			// }
			// this.v2.copy(inter2);
			// 
			var bezier = new _bezierJs2.default([this.v0.toObject(), this.v1.toObject(), this.v2.toObject(), this.v3.toObject()]);

			console.log('xx: ', bezier.offset(distance));

			return this;
		}
	}, {
		key: 'fromArray',
		value: function fromArray(array) {
			this.v0.set(array[0], array[1]);
			this.v1.set(array[2], array[3]);
			this.v2.set(array[4], array[5]);
			this.v3.set(array[6], array[7]);
			return this;
		}
	}, {
		key: 'toArray',
		value: function toArray() {
			return this.v0.toArray().concat(this.v1.toArray(), this.v2.toArray(), this.v3.toArray());
		}
	}]);

	return CubicBezierCurve;
}(_Curve3.default);

exports.default = CubicBezierCurve;