'use strict';

Object.defineProperty(exports, "__esModule", {
		value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Point = require('../math/Point2');

var _Point2 = _interopRequireDefault(_Point);

var _Approximately = require('../Approximately');

var _Approximately2 = _interopRequireDefault(_Approximately);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Curve = function () {
		function Curve() {
				_classCallCheck(this, Curve);
		}

		_createClass(Curve, [{
				key: 'getPoint',
				value: function getPoint(t) {
						console.warn('Curve: Warning, getPoint() not implemented!');
						return null;
				}
		}, {
				key: 'getPointAt',
				value: function getPointAt(u) {
						var t = this.getUtoTmapping(u);
						return this.getPoint(t);
				}
		}, {
				key: 'getLengths',
				value: function getLengths(divisions) {
						if (!divisions) {
								divisions = this.__arcLengthDivisions ? this.__arcLengthDivisions : 200;
						}

						if (this.cacheArcLengths && this.cacheArcLengths.length === divisions + 1 && !this.needsUpdate) {

								//console.log( "cached", this.cacheArcLengths );
								return this.cacheArcLengths;
						}

						this.needsUpdate = false;

						var cache = [];
						var current = void 0,
						    last = this.getPoint(0);
						var p = void 0,
						    sum = 0;

						cache.push(0);

						for (p = 1; p <= divisions; p++) {

								current = this.getPoint(p / divisions);
								sum += current.distanceTo(last);
								cache.push(sum);
								last = current;
						}

						this.cacheArcLengths = cache;

						return cache; // { sums: cache, sum:sum }; Sum is in the last element.
				}

				// Given u ( 0 .. 1 ), get a t to find p. This gives you points which are equidistant

		}, {
				key: 'getUtoTmapping',
				value: function getUtoTmapping(u, distance) {

						var arcLengths = this.getLengths();

						var i = 0,
						    il = arcLengths.length;

						var targetArcLength = void 0; // The targeted u distance value to get

						if (distance) {

								targetArcLength = distance;
						} else {

								targetArcLength = u * arcLengths[il - 1];
						}

						//let time = Date.now();

						// binary search for the index with largest value smaller than target u distance

						var low = 0,
						    high = il - 1,
						    comparison = void 0;

						while (low <= high) {

								i = Math.floor(low + (high - low) / 2); // less likely to overflow, though probably not issue here, JS doesn't really have integers, all numbers are floats

								comparison = arcLengths[i] - targetArcLength;

								if (comparison < 0) {

										low = i + 1;
								} else if (comparison > 0) {

										high = i - 1;
								} else {

										high = i;
										break;

										// DONE
								}
						}

						i = high;

						//console.log('b' , i, low, high, Date.now()- time);

						if (arcLengths[i] === targetArcLength) {

								var _t = i / (il - 1);
								return _t;
						}

						// we could get finer grain at lengths, or use simple interpolation between two points

						var lengthBefore = arcLengths[i];
						var lengthAfter = arcLengths[i + 1];

						var segmentLength = lengthAfter - lengthBefore;

						// determine where we are between the 'before' and 'after' points

						var segmentFraction = (targetArcLength - lengthBefore) / segmentLength;

						// add that fractional amount to t

						var t = (i + segmentFraction) / (il - 1);

						return t;
				}
		}, {
				key: 'getTangentAt',
				value: function getTangentAt(u) {
						var t = this.getUtoTmapping(u);
						return this.getTangent(t);
				}
		}, {
				key: 'getNormal',
				value: function getNormal(t) {
						var d = this.getTangent(t);
						var q = d.length();

						if ((0, _Approximately2.default)(q, 0)) {
								return null;
						}

						return new _Point2.default(-d.y / q, d.x / q);
				}
		}]);

		return Curve;
}();

exports.default = Curve;