'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Curve2 = require('./Curve');

var _Curve3 = _interopRequireDefault(_Curve2);

var _Point = require('../math/Point2');

var _Point2 = _interopRequireDefault(_Point);

var _Approximately = require('../Approximately');

var _Approximately2 = _interopRequireDefault(_Approximately);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LineCurve = function (_Curve) {
	_inherits(LineCurve, _Curve);

	function LineCurve(v0, v1) {
		_classCallCheck(this, LineCurve);

		var _this = _possibleConstructorReturn(this, (LineCurve.__proto__ || Object.getPrototypeOf(LineCurve)).call(this));

		_this.v0 = v0;
		_this.v1 = v1;
		_this.type = 'LineCurve';
		return _this;
	}

	_createClass(LineCurve, [{
		key: 'copy',
		value: function copy(line) {
			this.v0.copy(line.v0);
			this.v1.copy(line.v1);
			return this;
		}
	}, {
		key: 'clone',
		value: function clone() {
			return new LineCurve().copy(this);
		}
	}, {
		key: 'getPoint',
		value: function getPoint(t) {
			var point = this.v1.clone().subtract(this.v0);
			point.multiplyScalar(t).add(this.v0);

			return point;
		}
	}, {
		key: 'getTangent',
		value: function getTangent(t) {
			var tanget = this.v1.clone().subtract(this.v0);
			return tanget;
		}
	}, {
		key: 'offset',
		value: function offset(distance) {
			if (!this.v0.isApproximately(this.v1)) {
				var n = this.getNormal(0).normalize(distance);
				// console.log(n);
				this.v0.copy(this.v0.add(n));

				this.v1.copy(this.v1.add(n));
			}

			return this;
		}
	}, {
		key: 'intersection',
		value: function intersection(line) {
			var k1 = void 0,
			    b1 = void 0,
			    k2 = void 0,
			    b2 = void 0;
			if ((0, _Approximately2.default)(this.v0.x, this.v1.x)) {
				k1 = 0;
				b1 = this.v0.x;
			} else {
				k1 = (this.v0.y - this.v1.y) / (this.v0.x - this.v1.x);
				b1 = (this.v0.x * this.v1.y - this.v1.x * this.v0.y) / (this.v0.x - this.v1.x);
			}

			if ((0, _Approximately2.default)(line.v0.x, line.v1.x)) {
				k2 = 0;
				b2 = line.v0.x;
			} else {
				k2 = (line.v0.y - line.v1.y) / (line.v0.x - line.v1.x);
				b2 = (line.v0.x * line.v1.y - line.v1.x * line.v0.y) / (line.v0.x - line.v1.x);
			}

			if ((0, _Approximately2.default)(k1, k2)) {
				return null;
			} else {
				return new _Point2.default((b2 - b1) / (k1 - k2), (k1 * b2 - k2 * b1) / (k1 - k2));
			}
		}
	}, {
		key: 'fromArray',
		value: function fromArray(array) {
			this.v0.set(array[0], array[1]);
			this.v1.set(array[2], array[3]);
			return this;
		}
	}, {
		key: 'toArray',
		value: function toArray() {
			return this.v0.toArray().concat(this.v1.toArray());
		}
	}]);

	return LineCurve;
}(_Curve3.default);

exports.default = LineCurve;