'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Curve2 = require('./Curve');

var _Curve3 = _interopRequireDefault(_Curve2);

var _Point = require('../math/Point2');

var _Point2 = _interopRequireDefault(_Point);

var _utils = require('./utils');

var _LineCurve = require('./LineCurve');

var _LineCurve2 = _interopRequireDefault(_LineCurve);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var QuadraticBezierCurve = function (_Curve) {
	_inherits(QuadraticBezierCurve, _Curve);

	function QuadraticBezierCurve(v0, v1, v2) {
		_classCallCheck(this, QuadraticBezierCurve);

		var _this = _possibleConstructorReturn(this, (QuadraticBezierCurve.__proto__ || Object.getPrototypeOf(QuadraticBezierCurve)).call(this));

		_this.v0 = v0;
		_this.v1 = v1;
		_this.v2 = v2;
		_this.type = 'QuadraticBezierCurve';
		return _this;
	}

	_createClass(QuadraticBezierCurve, [{
		key: 'copy',
		value: function copy(quadratic) {
			this.v0.copy(quadratic.v0);
			this.v1.copy(quadratic.v1);
			this.v2.copy(quadratic.v2);

			return this;
		}
	}, {
		key: 'clone',
		value: function clone() {
			return new QuadraticBezierCurve().copy(this);
		}
	}, {
		key: 'getPoint',
		value: function getPoint(t) {
			return new _Point2.default((0, _utils.QuadraticBezierPointFormula)(t, this.v0.x, this.v1.x, this.v2.x, this.v3.x), (0, _utils.QuadraticBezierPointFormula)(t, this.v0.y, this.v1.y, this.v2.y, this.v3.y));
		}
	}, {
		key: 'getTangent',
		value: function getTangent(t) {
			return new _Point2.default((0, _utils.QuadraticBezierTangentFormula)(t, this.v0.x, this.v1.x, this.v2.x, this.v3.x), (0, _utils.QuadraticBezierTangentFormula)(t, this.v0.y, this.v1.y, this.v2.y, this.v3.y));
		}
	}, {
		key: 'offset',
		value: function offset(distance) {
			var l1 = new _LineCurve2.default(this.v0.clone(), this.v1.clone());
			var l2 = new _LineCurve2.default(this.v1.clone(), this.v2.clone());
			l1.offset(distance);
			l2.offset(distance);

			this.v0.copy(l1.v0);
			this.v2.copy(l2.v1);

			var inter = l1.intersection(l2);
			if (!inter) {
				inter = l1.v1;
			}
			this.v1.copy(inter);

			return this;
		}
	}, {
		key: 'fromArray',
		value: function fromArray(array) {
			this.v0.set(array[0], array[1]);
			this.v1.set(array[2], array[3]);
			this.v2.set(array[4], array[5]);
			return this;
		}
	}, {
		key: 'toArray',
		value: function toArray() {
			return this.v0.toArray().concat(this.v1.toArray(), this.v2.toArray());
		}
	}]);

	return QuadraticBezierCurve;
}(_Curve3.default);

exports.default = QuadraticBezierCurve;