'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

exports.default = function (len, radix) {
	var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.split(''),
	    uuid = [],
	    i = void 0;
	radix = radix || chars.length;

	if (len) {
		// Compact form
		for (var _i = 0; _i < len; _i++) {
			uuid[_i] = chars[0 | Math.random() * radix];
		}
	} else {
		// rfc4122, version 4 form
		var r = void 0;
		// rfc4122 requires these characters
		uuid[8] = uuid[13] = uuid[18] = uuid[23] = '-';
		uuid[14] = '4';

		// Fill in random data.  At i==19 set the high bits of clock sequence as
		// per rfc4122, sec. 4.1.5
		for (var _i2 = 0; _i2 < 36; _i2++) {
			if (!uuid[_i2]) {
				r = 0 | Math.random() * 16;
				uuid[_i2] = chars[_i2 == 19 ? r & 0x3 | 0x8 : r];
			}
		}
	}

	return uuid.join('');
};