'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Approximately = require('../Approximately');

var _Approximately2 = _interopRequireDefault(_Approximately);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Vector2 = function () {
    function Vector2(x, y) {
        _classCallCheck(this, Vector2);

        this.x = x || 0;
        this.y = y || 0;
    }

    _createClass(Vector2, [{
        key: 'set',
        value: function set(x, y) {
            this.x = x;
            this.y = y;
            return this;
        }
    }, {
        key: 'equals',
        value: function equals(v2) {
            return this === v2 || v2 && (this.x === v2.x && this.y === v2.y || Array.isArray(v2) && this.x === v2[0] && this.y === v2[1]) || false;
        }
    }, {
        key: 'copy',
        value: function copy(v2) {
            this.x = v2.x;
            this.y = v2.y;
            return this;
        }
    }, {
        key: 'clone',
        value: function clone() {
            return new Vector2(this.x, this.y);
        }
    }, {
        key: 'length',
        value: function length() {
            return Math.sqrt(this.x * this.x + this.y * this.y);
        }
    }, {
        key: 'distanceToSquared',
        value: function distanceToSquared(v2) {
            var dx = this.x - v2.x,
                dy = this.y - v2.y;
            return dx * dx + dy * dy;
        }
    }, {
        key: 'distanceTo',
        value: function distanceTo(v2) {
            return Math.sqrt(this.distanceToSquared(v2));
        }
    }, {
        key: 'normalize',
        value: function normalize(length) {
            if (length === undefined) {
                length = 1;
            }

            this.divideScalar(this.length()).multiplyScalar(length);

            return this;
        }
    }, {
        key: 'add',
        value: function add(v2) {
            this.x += v2.x;
            this.y += v2.y;
            return this;
        }
    }, {
        key: 'subtract',
        value: function subtract(v2) {
            this.x -= v2.x;
            this.y -= v2.y;
            return this;
        }
    }, {
        key: 'multiply',
        value: function multiply(v2) {
            this.x *= v2.x;
            this.y *= v2.y;
            return this;
        }
    }, {
        key: 'multiplyScalar',
        value: function multiplyScalar(s) {
            this.x *= s;
            this.y *= s;

            return this;
        }
    }, {
        key: 'divide',
        value: function divide(v2) {
            this.x /= v2.x;
            this.y /= v2.y;

            return this;
        }
    }, {
        key: 'divideScalar',
        value: function divideScalar(s) {
            return this.multiplyScalar(1 / s);
        }
    }, {
        key: 'modulo',
        value: function modulo(v2) {
            this.x %= v2.x;
            this.y %= v2.y;
            return this;
        }
    }, {
        key: 'negate',
        value: function negate() {
            return this.multiplyScalar(-1);
        }
    }, {
        key: 'isZero',
        value: function isZero() {
            return this.x == 0 && this.y == 0;
        }
    }, {
        key: 'isNaN',
        value: function (_isNaN) {
            function isNaN() {
                return _isNaN.apply(this, arguments);
            }

            isNaN.toString = function () {
                return _isNaN.toString();
            };

            return isNaN;
        }(function () {
            return isNaN(this.x) || isNaN(this.y);
        })
    }, {
        key: 'isApproximately',
        value: function isApproximately(v2) {
            return (0, _Approximately2.default)(this.x, v2.x) && (0, _Approximately2.default)(this.y, v2.y);
        }
    }, {
        key: 'dot',
        value: function dot(v2) {
            return this.x * v2.x + this.y * v2.y;
        }
    }, {
        key: 'cross',
        value: function cross(v2) {
            return this.x * v2.y - this.y * v2.x;
        }
    }, {
        key: 'fromArray',
        value: function fromArray(array) {
            this.x = array[0];
            this.y = array[1];

            return this;
        }
    }, {
        key: 'toArray',
        value: function toArray() {
            return [this.x, this.y];
        }
    }, {
        key: 'toObject',
        value: function toObject() {
            return {
                x: this.x,
                y: this.y
            };
        }
    }]);

    return Vector2;
}();

exports.default = Vector2;